function varargout = Control(varargin)
% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Control_OpeningFcn, ...
                   'gui_OutputFcn',  @Control_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end

% End initialization code - DO NOT EDIT


% --- Executes during object creation, after setting all properties.
function Control_CreateFcn(hObject, eventdata, handles)
% hObject    handle to pushbutton_play (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% A new global variable is defined in order to be accesible by STOP button.


% --- Executes just before Control_03 is made visible.
function Control_OpeningFcn(hObject, eventdata, handles, varargin)

addpath(genpath('./lib'));


handles.output = hObject;
guidata(hObject, handles);

set(hObject,'CloseRequestFcn',@Control_CloseRequestFcn);

setControlInit();

% Display welcome msg
fprintf('\n\n\n Multi Modal Data Collection Visualization Tool\n');
fprintf('\n 2010 Robotics Institute - Carnegie Mellon University\n');
fprintf('\n CONTROL GUI \n');
fprintf('\n ----------------------------------------------------\n\n');


% --- Outputs from this function are returned to the command line.
function varargout = Control_OutputFcn(hObject, eventdata, handles) 
% Get default command line output from handles structure
varargout{1} = handles.output;


function Control_CloseRequestFcn(hObject, eventdata, handles)
global state
global hand

%state = state_stop (handles, state);

if ~isempty(hand)
    try
        delete(hand.h_fig); 
    catch ME
        disp('Closing Figure with all Views (''hand'')... It''s already closed');
    end
    clear hand
end
state = 'noInit';
delete(gcf)
close all


% --- Executes on button press in pushbutton_play.
function pushbutton_play_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_playtoini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state
global counter
global whatShow
global each_handle_camera
global lengthAllCam
global direction
global recording
global mov
global hand


[state, counter, whatData, each_handle_camera] = initState (state, counter, each_handle_camera, handles);

if strcmp(state, 'noInit')
    disp('No data is loaded');
    return
    
elseif ~strcmp(state, 'playing')
    state = state_play (recording, handles);
    
    % Find direction
    if get(handles.togglebutton_playtoini, 'Value') == get(handles.togglebutton_playtoini,'Max')
        direction = -1;
    else
        direction = 1;
    end

    % Play ...
    while strcmp(state,'playing') && counter > 0 && counter <= lengthAllCam
        playData(whatData, whatShow, each_handle_camera, handles, counter);
        counter = counter + direction;
        drawnow;
        if recording==1
            %frame=getframe(hand.h_fig);
            %mov = addframe(mov,frame);
        end
    end
    
    % If one end has been reached, set an indexable value
    if (counter == 0) || (counter > lengthAllCam)
        state = state_stop (handles);
    end
    if counter == 0
        counter = 1;
    end
    if counter > lengthAllCam
        counter = lengthAllCam;
    end
    
end


% --- Executes on button press in pushbutton_pause.
function pushbutton_pause_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_pause (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state

state = state_paused (handles);


% --- Executes on button press in togglebutton_playtoini.
function togglebutton_playtoini_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_playtoini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global direction

if get(hObject,'Value') == get(hObject,'Max')
    direction = -1;
    set(hObject, 'BackgroundColor', [0.678 0.922 1.0]);
    
else
    direction = 1;
    set(hObject, 'BackgroundColor', 'default');
end


% --- Executes on button press in pushbutton_rew.
function pushbutton_rew_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_rew (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state
global whatShow
global counter
global each_handle_camera

[state, counter, whatData, each_handle_camera] = initState (state, counter, each_handle_camera, handles);

if strcmp(state, 'noInit')
    disp('No data is loaded');
    return
    
else
    state_lock (handles);
    
    towards = -1;
    counter = getJumpToFrame(towards, counter, whatData, handles);
    playData(whatData, whatShow, each_handle_camera, handles, counter);
    
    state = state_stop (handles);
end
    

% --- Executes on button press in pushbutton_fwd.
function pushbutton_fwd_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_fwd (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state
global whatShow
global counter
global each_handle_camera


[state, counter, whatData, each_handle_camera] = initState (state, counter, each_handle_camera, handles);
if strcmp(state, 'noInit')
    disp('No data is loaded');
    return
else
    state_lock (handles);
    
    towards = +1;
    counter = getJumpToFrame(towards, counter, whatData, handles);
    playData(whatData, whatShow, each_handle_camera, handles, counter);
    
    state = state_stop (handles);
end


% --- Executes on slider movement.
function slider1_Callback(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'Value') returns position of slider
%        get(hObject,'Min') and get(hObject,'Max') to determine range of slider

global state
global counter
global each_handle_camera
global whatShow
global lengthAllCam


[state, counter, whatData, each_handle_camera] = initState (state, counter, each_handle_camera, handles);

if strcmp(state, 'noInit')
    disp('No data is loaded');
    return
    
else
    
    value = round(get(hObject, 'Value') * lengthAllCam);
    if value == 0
        value = 1;
    end
    
    state_lock (handles);
    
    counter = value;
    if counter >0 && counter <= lengthAllCam
        playData(whatData, whatShow, each_handle_camera, handles, counter);
    end
    
    state = state_stop (handles);
    
end


% --- Executes on button press in pushbutton_stop.
function pushbutton_stop_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_stop (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global state
global counter
global each_handle_camera
global whatShow
global mov


whatData = whatDataIsLoaded();
if ~isempty(find(whatData, 1)) && ~strcmp(state, 'recording')
    counter = 1;

elseif strcmp(state, 'recording')
    %mov = close(mov);
end

state = state_stop (handles);
playData(whatData, whatShow, each_handle_camera, handles, counter);


% --- Executes on button press in pushbutton_label_begin.
function pushbutton_label_begin_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_label_begin (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global allTextTimeStamp
global counter
global labels

allLabel = {};

% For each label copy all its fields in one string
for i = 1 : size(labels, 1)
    allLabel{i} = [labels{i, 1} labels{i, 2} labels{i, 3}];
end

% Built a new label with new beginning time
% First, check if the current time is valid (mostly because it has not started yet)
if counter > 0 && counter <= length(allTextTimeStamp)
    
    % Distinguish if this label is new or the start time of an existing
    % label is being modified
    if get(handles.checkbox_label_list, 'Value') == get(handles.checkbox_label_list, 'Min')
        % If it's a new label start time stamp and name are stored
        currentLabel = { [allTextTimeStamp{counter} '  '] ...
            '................   ' get(handles.edit_label, 'String')};
        currentLabelStr = [currentLabel{1} currentLabel{2} currentLabel{3}];
	
	% If one of the existing labels is going to be modified
    else
        % Get the index of the label which is being modified
        index_selected = get(handles.listbox_labels, 'Value');

        % Create a new label changing with new timestamp and copying end
        % timestamp and name
        currentLabel = { [allTextTimeStamp{counter} '  '] ...
            labels{index_selected,2} labels{index_selected,3}};
        currentLabelStr = [currentLabel{1} '  ' currentLabel{2} currentLabel{3}];
        
        % As there is a new label, it removes the old one
        [labels, allLabel] = removeOldEntry(index_selected, labels, allLabel);
    end
    
    % Update the listbox
    labels = showLabels(handles, currentLabel, currentLabelStr, labels, allLabel);
else
    state = state_stop (handles);
    errordlg('You must use a valid Timestamp', 'Error: Timestamp not valid')
end


% --- Executes on button press in pushbutton_label_end.
function pushbutton_label_end_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_label_end (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global allTextTimeStamp
global counter
global labels

allLabel = {};

% Get the file selected in the listbox
index_selected = get(handles.listbox_labels, 'Value');
index_selected = index_selected(1);

% Check if the current time is valid (mostly because it has not started yet)
if counter > 0 && counter <= length(allTextTimeStamp)

    % Update variable "labels" with the right time
    labels{index_selected, 2} = [allTextTimeStamp{counter} '   '];

    % Update labels in the listbox
    for i = 1 : size(labels, 1)
        allLabel{i} = [labels{i, 1} labels{i, 2} labels{i, 3}];
    end

    % Display new labels (or at least modified)
    set(handles.listbox_labels, 'String', allLabel);
    
else
    state = state_stop (handles);
	errordlg('You must use a valid Timestamp', 'Error: Timestamp not valid')
end


% --- Executes on button press in pushbutton_remove_label.
function pushbutton_remove_label_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_remove_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
    % Built a new label with new beginning time
    
global labels    

allLabel = {};

% For each label copy all its fields in one string
for i = 1 : size(labels, 1)
    allLabel{i} = [labels{i, 1} labels{i, 2} labels{i, 3}];
end

% Get the file selected in the listbox
index_selected = get(handles.listbox_labels,'Value');
index_selected = index_selected(1);

for i = 1 : length(index_selected)
    % Remove old entries
    [labels, allLabel] = removeOldEntry(index_selected(i), labels, allLabel);
end

% There is no new label
currentLabel = {};
currentLabelStr = [];

% Display the new list without any new label
labels = showLabels(handles, currentLabel, currentLabelStr, labels, allLabel);


% --- Executes on selection change in listbox_labels.
function listbox_labels_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_labels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_labels contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_labels
% contents = get(hObject,'String')
% ListboxTop

global labels

% Indicate the user that he is not going to add a new label
% disabling the label name edit control and setting the name of the
% label selected.
if ~isempty(labels)
    modifyingExisting = get(handles.checkbox_label_list, 'Value');
    if  modifyingExisting == get(handles.checkbox_label_list, 'Max')
        index_selected = get(hObject,'Value');
        set(handles.edit_label, 'String', labels{index_selected, 3});
    end
end


% --- Executes on button press in checkbox_label_list.
function checkbox_label_list_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_label_list (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_label_list

global labels

if ~isempty(labels)
    if  get(hObject,'Value') == get(hObject, 'Min')
        set(handles.edit_label, 'Enable', 'on');
        set(handles.edit_label, 'String', '');
    else
        set(handles.edit_label, 'Enable', 'off');
        index_selected = get(handles.listbox_labels  ,'Value');
        set(handles.edit_label, 'String', labels{index_selected, 3});
    end
else
    set(hObject, 'Value', get(hObject, 'Min'));
    set(handles.edit_label, 'Enable', 'on');
    set(handles.edit_label, 'String', '');
end
    

% --- Executes on button press in pushbutton_goto_label.
function pushbutton_goto_label_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_goto_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function menu_data_Callback(hObject, eventdata, handles)
% hObject    handle to menu_data (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function menu_label_Callback(hObject, eventdata, handles)
% hObject    handle to menu_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function menu_label_load_Callback(hObject, eventdata, handles)
% hObject    handle to menu_label_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global labels

if ~isempty(labels)
    usersAnswer = questdlg('Pressing OK will clear label list','!! Warning !!', 'No');
    if strcmp(usersAnswer, 'Yes')
        clear labels
    end
end
[fileName, pathName] = uigetfile({'*.*',  'All Files (*.*)'}, 'Load Labels', 'label.txt');
if fileName ~= 0
    file = [pathName fileName];
    fid = fopen(file);
    labels = textscan(fid, '%s %s %s', 'delimiter', '');
    fclose(fid);
end


function menu_label_save_Callback(hObject, eventdata, handles)
% hObject    handle to menu_label_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

labelList = get(handles.listbox_labels,'String');

[fileName, pathName] = uiputfile(...
    {'*.*',  'All Files (*.*)'}, 'Save as', 'label.txt');

if fileName ~=0 && pathname ~= 0
    fid=fopen([pathName fileName],'a+');

    if iscell(labelList)
         cell2file(fid, labelList, 'delimiter', '\t', 'EndOfLine', '\r\n');
    else
         cell2file(fid, {labelList}, 'EndOfLine', '\r\n');
    end
    fclose(fid);
end


function menu_label_clear_Callback(hObject, eventdata, handles)
% hObject    handle to menu_label_clear (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu__offset_load_Callback(hObject, eventdata, handles)
% hObject    handle to menu__offset_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global path
global cam
global NUM_OFFSETS


[fileName, pathName] = uigetfile({'*.*',  'All Files (*.*)'}, 'Load Offsets', [path filesep 'offsets.txt']);
if ischar(fileName) && ischar(pathName)
    file = [pathName fileName];
    fid = fopen(file);
    text = textscan(fid, '%s %d', 'Delimiter', '\t', 'HeaderLines', 1);
    offset = text{2};
    fclose(fid);
    if length(offset) == NUM_OFFSETS
        camNames = cell(1,6);
        if isempty(find(isnan(offset)))
            for i=1:6
                camNames{i} = cam{i}.id;
                if text{1}{i+2} ~= camNames{i}
                    fprintf('ERROR: Camera names doesn''t match! offset file: %s, loaded variable: %s\n',field{i+2},camNames{i});
                    errordlg('At least one camera names is different than the corresponding global variable.', 'Error Loading: OFFSETS doesn'' match');
                    return
                end
            end
            set(handles.edit_offset_imu_cb, 'String', num2str(offset(1)));
            set(handles.edit_offset_imu_bt, 'String', num2str(offset(2)));
            set(handles.edit_offset_cam1, 'String', num2str(offset(3)));
            set(handles.edit_offset_cam2, 'String', num2str(offset(4)));
            set(handles.edit_offset_cam3, 'String', num2str(offset(5)));
            set(handles.edit_offset_cam4, 'String', num2str(offset(6)));
            set(handles.edit_offset_cam5, 'String', num2str(offset(7)));
            set(handles.edit_offset_cam6, 'String', num2str(offset(8)));
            set(handles.edit_offset_audio, 'String', num2str(offset(9)));
            set(handles.edit_offset_mocap, 'String', num2str(offset(10)));
            set(handles.edit_offset_ewatch, 'String', num2str(offset(11)));
        else
            errordlg('One value is not a number offset.', 'Error Loading: OFFSETS File not valid');
       end
    else
       errordlg(['Number of lines should be 9, instead of : ' num2str(length(offset)) ], 'Error Loading: OFFSETS File not valid');
    end
end


% --------------------------------------------------------------------
function menu__offset_save_Callback(hObject, eventdata, handles)
% hObject    handle to menu__offset_save (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global path
global cam
global NUM_OFFSETS

field = {'IMU_CB' 'IMU_BT' 'C1' 'C2' 'C3' 'C4' 'C5' 'C6' 'Audio' 'MC' 'RFID' 'eWatch'};

% Fill with real camera names
for i=1:6
    if ~isempty(cam{i})
        field{2+i} = cam{i}.id;
    end
end

offset = [ 
    round(str2double(get(handles.edit_offset_imu_cb, 'String')))
    round(str2double(get(handles.edit_offset_imu_bt, 'String')))
    round(str2double(get(handles.edit_offset_cam1, 'String')))
    round(str2double(get(handles.edit_offset_cam2, 'String')))
    round(str2double(get(handles.edit_offset_cam3, 'String')))
    round(str2double(get(handles.edit_offset_cam4, 'String')))
    round(str2double(get(handles.edit_offset_cam5, 'String')))
    round(str2double(get(handles.edit_offset_cam6, 'String')))
    round(str2double(get(handles.edit_offset_audio, 'String')))
    round(str2double(get(handles.edit_offset_mocap, 'String')))
    round(str2double(get(handles.edit_offset_rfid, 'String')))
    round(str2double(get(handles.edit_offset_ewatch, 'String')))
    ];

[fileName, pathName, filterindex] = uiputfile(...
    {'*.*',  'All Files (*.*)'}, 'Save as', [path filesep 'offsets.txt']);

if ~isempty(pathName) && ~isempty(fileName)
    try
        fid=fopen([pathName fileName],'w');
        fprintf(fid, '--- Offset file created by tool. Don''t edit. ---\n');
        for i=1:NUM_OFFSETS 
            fprintf(fid, '%s\t%d\n', field{i}, offset(i));
        end
        fclose(fid);
    catch ME
        msg = ['Error: It was not posible to save the offsets file'];
        errordlg(msg, 'Error Saving: OFFSETS File not valid');
        disp(msg);
        disp(ME.message);
    end
end


function menu_data_load_Callback(hObject, eventdata, handles)
% hObject    handle to menu_data_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
whatData = whatDataIsLoaded();
if ~isempty(find(whatData, 1))
    usersAnswer = questdlg('Pressing OK will clear memory','!! Warning !!', 'No');
    if strcmp(usersAnswer, 'Yes')
        clear showimu_cb showimu_bt showCams showAudio allTextTimeStamp cam accel audio
    end
end
LoadFile


function menu_data_clear_Callback(hObject, eventdata, handles)
% hObject    handle to menu_data_clear (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

usersAnswer = questdlg('Pressing OK will clear memory','!! Warning !!', 'No');
if strcmp(usersAnswer, 'Yes')
    clear showimu_cb showimu_bt showCams showAudio allTextTimeStamp cam accel audio
end


function menu_data_showInfo_Callback(hObject, eventdata, handles)
% hObject    handle to menu_data_showInfo (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global infoDataLoaded
if ~iscell(infoDataLoaded)
    infoDataLoaded = {'Sensors : Not loaded' ...
        'Cam 1   :   Not loaded' 'Cam 2   :   Not loaded' 'Cam 3   :   Not loaded' ...
        'Cam 4   :   Not loaded' 'Cam 5   :   Not loaded' 'Cam Onboard   :   Not loaded'};
end

h = msgbox(infoDataLoaded, 'Data Load Results', 'help');


% --------------------------------------------------------------------
function menu_tools_Callback(hObject, eventdata, handles)
% hObject    handle to menu_tools (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_tools_record_Callback(hObject, eventdata, handles)
% hObject    handle to menu_tools_record (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global state
global mov
global recording
global hand
global framecount

if ~isempty(hand)
    %prompt = {'Frames will be saved in folder videoframes\nMake sure the folder is created\n\nFrames are stored when play button is pressed'};
    warndlg(['Frames will be saved in folder videoframes. Make sure the folder is created. Frames are stored when play button is pressed']);
    recording = 1;
    set(handles.menu_tools_record,'Enable','off');
    set(handles.stoprec,'Enable','on');
    framecount = 0;
    
    %prompt = {'Enter name of avi file:'};
    %dlg_title = 'Input for video recording';
    %num_lines = 1;
    %def = {'multiView.avi'};

    %aviname = inputdlg(prompt,dlg_title,num_lines,def);

    %if ~isempty(aviname)
    %    try
    %        aviname = aviname{1};
    %        mov = avifile(aviname, 'compression', 'X264', 'fps', 60);
    %        state = state_recording (state, handles);
    %        recording = 1;
    %        set(handles.stoprec,'Enable','on');
    %        set(handles.menu_tools_record,'Enable','off');
    %        framecount = 0;
    %    catch ME
    %        errordlg('File name not valid');
    %        disp(ME.message)
    %    end        
    %end
end


function slider1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to slider1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: slider controls usually have a light gray background.
if isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor',[.9 .9 .9]);
end


function file_menu_Callback(hObject, eventdata, handles)
% hObject    handle to file_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function file_load_menu_Callback(hObject, eventdata, handles)
% hObject    handle to file_load_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[FileName,PathName,FilterIndex] = uigetfile('*.m', 'Open Data Files');

fig_load = openfig('filename.fig','reuse');

function file_close_menu_Callback(hObject, eventdata, handles)
% hObject    handle to file_close_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function view_menu_Callback(hObject, eventdata, handles)
% hObject    handle to view_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function view_accelerometer_menu_Callback(hObject, eventdata, handles)
% hObject    handle to view_accelerometer_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function view_video_menu_Callback(hObject, eventdata, handles)
% hObject    handle to view_video_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function view_audio_menu_Callback(hObject, eventdata, handles)
% hObject    handle to view_audio_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function edit_info_frame_Callback(hObject, eventdata, handles)
function edit_info_frame_CreateFcn(hObject, eventdata, handles)
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function pushbutton_offset_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_offset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


function edit_step_Callback(hObject, eventdata, handles)
% hObject    handle to edit_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function edit_step_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_step (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function togglebutton_playtoini_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to togglebutton_playtoini (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function togglebutton_label_Callback(hObject, eventdata, handles)
% hObject    handle to togglebutton_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% 


function listbox_labels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_labels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_label_Callback(hObject, eventdata, handles)
% hObject    handle to edit_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function edit_label_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_label (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_show_labels.
function pushbutton_show_labels_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_show_labels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



function menu_offset_Callback(hObject, eventdata, handles)
% hObject    handle to menu_offset (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --- Executes on button press in checkbox_update_cam.
function checkbox_update_cam_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_update_cam (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_update_cam


function checkbox_update_imu_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_update_imu_bt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --- Executes on button press in checkbox_update_audio.
function checkbox_update_audio_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_update_audio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_update_audio


% --- Executes on button press in checkbox_update_mocap.
function checkbox_update_mocap_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_update_mocap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_update_mocap


% --- Executes on button press in checkbox_update_rfid.
function checkbox_update_rfid_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_update_rfid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_update_rfid


% --- Executes on button press in checkbox_update_ewatch.
function checkbox_update_ewatch_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_update_ewatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_update_ewatch


function edit_offset_cam1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_cam2 as text
%     

function edit_offset_cam1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_cam2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_cam2 as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_cam2 as a double


% --- Executes during object creation, after setting all properties.
function edit_offset_cam2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_cam3_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_cam2 as text
%     


function edit_offset_cam3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_offset_cam4_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_cam6 as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_cam6 as a double


function edit_offset_cam4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_offset_cam5_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_cam6 as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_cam6 as a double

function edit_offset_cam5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_cam6_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_cam6 as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_cam6 as a double


% --- Executes during object creation, after setting all properties.
function edit_offset_cam6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_cam6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_imu_cb_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

function edit_offset_imu_cb_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_imu_bt_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_imu_bt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_imu_bt as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_imu_bt as a double


% --- Executes during object creation, after setting all properties.
function edit_offset_imu_bt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_imu_bt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_audio_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_audio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_audio as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_audio as a double


% --- Executes during object creation, after setting all properties.
function edit_offset_audio_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_audio (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_mocap_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_mocap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_mocap as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_mocap as a double


% --- Executes during object creation, after setting all properties.
function edit_offset_mocap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_mocap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_offset_rfid_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_rfid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_rfid as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_rfid as a double


% --- Executes during object creation, after setting all properties.
function edit_offset_rfid_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_rfid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_info_Callback(hObject, eventdata, handles)
% hObject    handle to edit_info (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_info as text
%        str2double(get(hObject,'String')) returns contents of edit_info as a double


% --- Executes during object creation, after setting all properties.
function edit_info_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_info (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in cameraFrames.
function cameraFrames_Callback(hObject, eventdata, handles)
% hObject    handle to cameraFrames (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
%[cam, imageName, frameEachCam, id] = getCurrentCamAndFrame(whatData, currentTime, handle_control);
global cam
global frameEachCam
global mainPath


[fileName, pathName, filterindex] = uiputfile(...
    {'*.*',  'All Files (*.*)'}, 'Save as', [mainPath 'frames.txt']);

if ~isempty(pathName) && ~isempty(fileName)
    try
    fid = fopen([pathName fileName], 'w');
    fprintf(fid,'Serial\tMatlab Frame\tFirst Frame\t\tVirtualDub Frame\n');
    for i=1:6
        if ~isempty(cam{i}) && ~isempty(frameEachCam{i})
            temp=str2num(frameEachCam{i});
            dif=temp-cam{i}.numFrames(1);
            %fprintf('%d %d\n',frameEachCam{i},cam{i}.numFrames(1))
            fprintf(fid,'%s\t%d\t\t%d\t\t%d\n',cam{i}.id,temp,cam{i}.numFrames(1),dif);
        end
    end
    fclose(fid);
    catch ME
        msg = ['Error: It was not posible to save the frames file'];
        errordlg(msg, 'Error Saving: FRAMES File not valid');
        disp(msg);
        disp(ME.message);
    end
end



    


% --- Executes on button press in saveoffsets.
function saveoffsets_Callback(hObject, eventdata, handles)
% hObject    handle to saveoffsets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global path
global cam
global NUM_OFFSETS

field = {'IMU_CB' 'IMU_BT' 'C1' 'C2' 'C3' 'C4' 'C5' 'C6' 'Audio' 'MC' 'RFID' 'eWatch'};

% Fill with real camera names
for i=1:6
    if ~isempty(cam{i})
        field{2+i} = cam{i}.id;
    end
end

offset = [ 
    round(str2double(get(handles.edit_offset_imu_cb, 'String')))
    round(str2double(get(handles.edit_offset_imu_bt, 'String')))
    round(str2double(get(handles.edit_offset_cam1, 'String')))
    round(str2double(get(handles.edit_offset_cam2, 'String')))
    round(str2double(get(handles.edit_offset_cam3, 'String')))
    round(str2double(get(handles.edit_offset_cam4, 'String')))
    round(str2double(get(handles.edit_offset_cam5, 'String')))
    round(str2double(get(handles.edit_offset_cam6, 'String')))
    round(str2double(get(handles.edit_offset_audio, 'String')))
    round(str2double(get(handles.edit_offset_mocap, 'String')))
    round(str2double(get(handles.edit_offset_rfid, 'String')))
    round(str2double(get(handles.edit_offset_ewatch, 'String')))
    ];

[fileName, pathName, filterindex] = uiputfile(...
    {'*.*',  'All Files (*.*)'}, 'Save as', [path filesep 'offsets.txt']);

if ~isempty(pathName) && ~isempty(fileName)
    try
        fid=fopen([pathName fileName],'w');
        fprintf(fid, '--- Offset file created by tool. Don''t edit. ---\n');
        for i=1:NUM_OFFSETS 
            fprintf(fid, '%s\t%d\n', field{i}, offset(i));
        end
        fclose(fid);
    catch ME
        msg = ['Error: It was not posible to save the offsets file'];
        errordlg(msg, 'Error Saving: OFFSETS File not valid');
        disp(msg);
        disp(ME.message);
    end
end



function edit_offset_ewatch_Callback(hObject, eventdata, handles)
% hObject    handle to edit_offset_ewatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_offset_ewatch as text
%        str2double(get(hObject,'String')) returns contents of edit_offset_ewatch as a double


% --- Executes during object creation, after setting all properties.
function edit_offset_ewatch_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_offset_ewatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --------------------------------------------------------------------
function stoprec_Callback(hObject, eventdata, handles)
% hObject    handle to stoprec (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global hand
global recording
global mov

if ~isempty(hand)
    set(handles.stoprec,'Enable','off');
    set(handles.menu_tools_record,'Enable','on');
    recording = 0;
    %mov = close(mov);
end
