function varargout = LoadFile(varargin)
% LOADFILE M-file for LoadFile.fig
%      LOADFILE, by itself, creates a new LOADFILE or raises the
%      existing
%      singleton*.
%
%      H = LOADFILE returns the handle to a new LOADFILE or the
%      handle to
%      the existing singleton*.
%
%      LOADFILE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LOADFILE.M with the given input
%      arguments.
%
%      LOADFILE('Property','Value',...) creates a new LOADFILE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before LoadFile_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are paghuissed to LoadFile_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help LoadFile

% Last Modified by Ricard v2.6 17-DEC-2009

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @LoadFile_OpeningFcn, ...
                   'gui_OutputFcn',  @LoadFile_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes during object creation, after setting all properties.
function figure1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes just before LoadFile is made visible.
function LoadFile_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to LoadFile (see VARARGIN)


addpath(genpath('./lib'));


% Choose default command line output for LoadFile
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes LoadFile wait for user response (see UIRESUME)
% uiwait(handles.figure1);

set(hObject,'CloseRequestFcn',@load_CloseRequestFcn);

% Some settings as global constant
global settings

settings = setDefaultSettings();


fprintf('\n\n\n Multi Modal Data Collection Visualization Tool\n');
fprintf('\n 2010 Robotics Institute - Carnegie Mellon University\n');
fprintf('\n LOAD FILE GUI\n');
fprintf('\n ----------------------------------------------------\n\n');







function load_CloseRequestFcn(hObject, eventdata, handles)

% Variables explained in pushbutton_load_Callback function

% Data variables 
global imu_cb
global imu_bt
global cam
global audio
global mocap
global rfid
global ewatch
% Control variables for saving loaded data in .mat format
global allowSave
global infoDataLoaded
global selectedData
global matPath



% Ask user for saving variables when closing
if allowSave == 1
    try
        userAnswer = questdlg( [ infoDataLoaded{:} ...
            'Do you want to store the variables as *.mat files?' ], ...
            'Data Load Results','Yes','No', 'Yes');

        if strcmp(userAnswer, 'Yes')
            if ~exist(matPath,'dir')
                mkdir(matPath);
            end
            for i=1:1:length(selectedData)
                if i == 1
                    if selectedData(i) == 1
                        tmpPath = [ matPath 'imu_cb.mat'];
                        save(tmpPath, 'imu_cb');
                    end
                elseif i == 2
                    if selectedData(i) == 1
                        tmpPath = [ matPath 'imu_bt.mat'];
                        save(tmpPath, 'imu_bt');
                    end
                elseif  i>=3 && i <=8 && ~isempty(find(selectedData(3:8),1))
                    if selectedData(i) == 1
                        tmpPath = [ matPath  'cam.mat'];
                        save(tmpPath, 'cam');
                    end
                elseif i == 9
                    if selectedData(i) == 1
                        tmpPath = [ matPath 'audio.mat'];
                        save(tmpPath, 'audio');
                    end
                elseif i == 10
                    if selectedData(i) == 1
                        tmpPath = [ matPath 'mocap.mat'];
                        save(tmpPath,'mocap');
                    end
                elseif i == 11
                    if selectedData(i) == 1
                        tmpPath = [ matPath 'rfid.mat'];
                        save(tmpPath,'rfid');
                    end
                elseif i ==12
                    if selectedData(i) == 1
                        tmpPath = [ matPath 'ewatch.mat'];
                        save(tmpPath,'ewatch');
                    end
                end
            end
        end

    catch ME
        errordlg('Error Saving Data in MATLAB format');
        disp(ME.message)
        delete(gcf)
    end
end
delete(gcf)





% --- Executes on button press in pushbutton_load.
function pushbutton_load_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_load (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global settings

% Data variables
global imu_bt  % Cell with all data of every Sparkfun 6DOFv4 Bluetooth IMU sensor
global imu_cb  % Cell with all data of every Microstran 3DMGX1 cabled IMU sensor
global cam     % Cell with all data of every camera
global audio   % Cell with all data of every microphone
global mocap   % Cell with all MoCap data (markers, timing...)
global rfid    % Cell with all data of RFID bracelet (two columns: time, tag)
global ewatch  % Cell with all data of eWatch (accelerometers and light)

% Number of loaded IMU sensors 
global numberOfimu_bt  % Number of loaded Sparkfun sensors
global numberOfimu_cb  % Number of loaded cabled sensors

% Number of samples in 
global lengthimu_bt
global lengthimu_cb
global lengthAllCam

global allTimeStamp
global allTextTimeStamp  % Cell containing the union of all timestamps of 
                         % everycamera in text format (if they are 
                         % repeated are stored just once)

% Variables needed to save data when closing gui
global infoDataLoaded
global allowSave;
global selectedData
global matPath
global mainPath

% The simplest status automata: START, when Play everything turns off
set(hObject, 'Enable', 'off');


% Initialize variables
currentTime = [];
imu_bt = [];
imu_cb = [];
cam = {[] [] [] [] [] []};
audio = {[] [] [] [] []};
mocap = [];
numberOfImu_bt = [];
numberOfImu_cb = [];
lengthAllCam = [];
allTimeStamp = [];
allTextTimeStamp = [];

allowSave = 0;
imuLoaded = 0;
camLoaded = 0;
userAnsLoadCam = 0;
audioLoaded = 0;
mocapLoaded = 0;
rfidLoaded = 0;
ewatchLoaded = 0;
allTextTimestampsLoaded = 0;



handles_waitLoad = waitbar(1/100,{'Loading Data Files ...' ...
    'It may take several minutes'});


% Check and/or set camera names before loading
setCamNames(handles, settings);
% Check and/or set paths before loading
[ mainPath, paths, matPath ] = setPaths(handles, settings);

% Figure out what data should be loaded based on checkboxes
selectedData = getSelectedData (handles);

try
           
    % For everty data source...
    for i=1:length(selectedData)
        
        % Load data from IMU sensors
        if (i==1) || (i==2)
            if (i==1), 
                kindImu='imu_cb'; 
            else
                kindImu='imu_bt'; 
            end;
            
            if selectedData(i)
                disp('Loading data from IMU sensors ...');

                % Try to load *.mat file
                tmpPath = [ matPath kindImu '.mat'];
                if exist(tmpPath, 'file')
                    disp(['Found Matlab data file for IMU sensors named : ' tmpPath])
                    userAnswer = questdlg( ['Found Matlab data file for IMU sensors named : ' ...
                        tmpPath '. Do you want to load it?'], 'Data Load Results','Yes','No', 'Cancel','Yes');
                    if strcmp(userAnswer, 'Yes')
                        load(tmpPath);
                        eval([kindImu '.Path = paths{i};']);
                        imuLoaded = 1;
                    elseif strcmp(userAnswer, 'Cancel')
                        break
                    end
                end
                
                % Get data from ASCII file
                if imuLoaded == 0
                    eval([kindImu '.Path = paths{i};']);
                    eval(['[' kindImu '.Data, ' kindImu '.timeSeconds, ' kindImu '.timeString, numberOf' ...
                        kindImu ',' kindImu '.id ] = getIMUData(' kindImu '.Path);']);
                    eval([kindImu '.currentFrame = 1;']);
                end
                
                if isfield(eval(kindImu), 'timeString')
                    % A time reference is needed just in case no cam is loaded
                    allTextTimeStamp = eval([kindImu '.timeString{1}']); 
                end
                
                % IMU timestamp has been loaded
                eval(['time' kindImu '= 1;']); 
                msgDisp = ['IMU Sensors ' kindImu ': OK. Samples = ' num2str(size(eval([kindImu '.timeSeconds']) ,1)) ' * ' num2str(eval(['numberOf' kindImu]))];
                
            else
                % IMU timestamp was not loaded
                eval(['time' kindImu '= 1;']); 
                msgDisp = ['IMU Sensors ' kindImu ': Not loaded'];
            end
            
            % Display IMU info for user
            infoDataLoaded = {msgDisp};
            disp(msgDisp);    
            waitbar(i/length(selectedData));

            
        % Load data from the corresponding camera (i-2 in 1:6)
        % Actually it only takes the timestamp files and leave the images
        % for whenever they are needed
        elseif ~isempty(find(3:8 == i)) % there are up to six cameras
            disp (['Loading data from Camera ' num2str(i-2) ' ...']);
            
            if selectedData(i) && camLoaded == 0 && userAnsLoadCam ==0
                % Try to load *.mat file
                tmpPath = [ matPath 'cam.mat'];
                if exist(tmpPath, 'file') 
                    disp(['Found Matlab data file for timestamp of camera ' num2str(i-2) ', named : ' tmpPath])
                    userAnswer = questdlg( ['Found Matlab data file for timestamp of camera ' ...
                        num2str(i-2) ', named : ' tmpPath '. Do you want to load it?'], 'Data Load Results','Yes','No', 'Cancel','Yes');
                    if strcmp(userAnswer, 'Yes')
                        load(tmpPath);
                        whatData = whatDataIsLoaded();
                        for j=3:8
                            if whatData(j)==1
                                cam{j-2}.File = paths{j};
                            end
                        end
                        camLoaded =1;
                    elseif strcmp(userAnswer, 'Cancel')
                        break
                    end
                    userAnsLoadCam = 1;
                end
            end
           
            if selectedData(i) && camLoaded == 0
                % Path containing all camera's pictures is:
                cam{i-2}.File = paths{i};
                % Camera ID
                cam{i-2}.id = eval(['strrep( get(handles.edit_name_cam' num2str(i-2) ', ''String''), ''out'', '''');']);
                                
                % % If no *.mat file was loaded, get data from ASCII file 
                % parameters are path with timestamps and path for this camera:
                [cam{i-2}.textTimeStamp, cam{i-2}.num1stFrame, cam{i-2}.numlastFrame, ...
                    cam{i-2}.numFrames] = getCamTimeStamp(paths{end}, cam{i-2}.File, cam{i-2}.id);
                % Initialize
                cam{i-2}.currentFrame = 1; 
                msgDisp = ['Cam ' num2str(i-2) '   :   OK. Frames = ' num2str(length(cam{i-2}.textTimeStamp))];
                
            elseif selectedData(i) && camLoaded == 1
                msgDisp = ['Cam ' num2str(i-2) '   :   Loaded'];
            else
                msgDisp = ['Cam ' num2str(i-2) '   :   Not loaded'];
            end
            
            if selectedData(i)
                if timeimu_bt || timeimu_cb
                    % if timestamps of imu sensors were loaded they are 
                    % not necessary anymore
                    allTextTimeStamp = {}; 
                    timeimu_bt = 0;
                    timeimu_cb = 0;
                end
                % Add this camera's timestamp to the absolute timeline
                allTextTimeStamp = union(allTextTimeStamp, ...
                    cam{i-2}.textTimeStamp);
            end
            % Display camera info for user
            infoDataLoaded = {infoDataLoaded{:} msgDisp};
            disp(msgDisp);
            waitbar(i/length(selectedData));
            

        % Load data from the corresponding microphone (i-8 in 1:5)
        elseif i == 9
            if selectedData(i)
                disp(['Loading data from microphones...']);
                
                % Try to load *.mat file
                tmpPath = [ matPath 'audio.mat'];
                if exist(tmpPath, 'file') && audioLoaded == 0
                    disp(['Found Matlab data file for audio ' num2str(i-8) ' named : ' tmpPath])
                    userAnswer = questdlg( ['Found Matlab data file for audio ' ...
                        num2str(i-8) ' named : ' tmpPath '. Do you want to load it?'], 'Data Load Results','Yes','No', 'Cancel','Yes');
                    if strcmp(userAnswer, 'Yes')
                        load(tmpPath);
                        audio{i-8}.File = paths{i};
                        audioLoaded = 1;
                    elseif strcmp(userAnswer, 'Cancel')
                        break
                    end
                end
                
                % If no *.mat file was loaded, get data from WAV file
                if audioLoaded == 0
                    %Change audio names if necessary
                    paths = renameAudioFiles(mainPath, paths,i);                    
                    % Figure out which path
                    audio{i-8}.File = paths{i};
                    sepMatches = findstr(paths{i}, filesep);
                    audioTimePath = paths{i}(1:sepMatches(length(sepMatches)));
                    % Load data
                    nAudio = 0;
                    if settings.all_audio
                        nAudio = 5;
                    end
                    j=0;
                    for jj= i-8: i-8 + nAudio-1
                        j = j+1;
                        [audio{j}.timeStart, audio{j}.timeStop] = getAudioTimeInit(audioTimePath);
                        if j>1
                            [fi, ext] = strtok(audio{i-8}.File, '.');
                            audio{j}.File = [fi '-' num2str(j) ext];
                        end
                        [audio{j}.Data, audio{j}.timing] = readDecimateSamplesAudio(audio{j}.File, settings.audioDecimateFactor, ...
                            audio{j}.timeStart, audio{j}.timeStop);
                        msgDisp = ['Audio ' num2str(j) ' : OK. Only decimate samples loaded (1:400:size) : ' ...
                            num2str(length(audio{j}.Data)) ];
                    end
                end
            else
                msgDisp = ['Audio ' num2str(i-8) ' Not loaded']; 
            end
            
            infoDataLoaded = {infoDataLoaded{:}  msgDisp};
            disp(msgDisp);
            waitbar(i/length(selectedData));


        elseif i == 10
            if selectedData(i)
                disp('Loading MOCAP data ');
                
                % Try to load *.mat file
                tmpPath = [ matPath 'mocap.mat'];
                if exist(tmpPath, 'file')
                    disp(['Found Matlab data file for MOCAP named : ' tmpPath])
                    userAnswer = questdlg( ['Found Matlab data file for MOCAP named : ' ...
                        tmpPath '. Do you want to load it?'], 'Data Load Results','Yes','No', 'Cancel','Yes');
                    if strcmp(userAnswer, 'Yes')
                        load(tmpPath); 
                        mocap.path = paths{i};
                        mocapLoaded = 1;
                    elseif strcmp(userAnswer, 'Cancel')
                        break
                    end
                end
                
                % If no *.mat file was loaded, get data from *.ASF 
                % (skeleton) and *.AMC (markers' positions) files
                if mocapLoaded == 0
                    mocap.path = paths{i};

                    [mocap.wsDOF, mocap.wsFeat, mocap.wsPart, mocap.paraF] = readDataMOCAP(mocap.path);
                    mocap.timing = readTimeMOCAP(mocap.path, size(mocap.wsDOF.cord, 1));
                    
                    msgDisp = ['MOCAP : OK. (Decimate factor: ' num2str(settings.mocapDecimateFactor) ')' ...
                        num2str(length(mocap.wsDOF.cord)) ];
                end
            else
                msgDisp = 'MOCAP Not loaded';
            end
            
            infoDataLoaded = {infoDataLoaded{:}  msgDisp};
            disp(msgDisp);
            waitbar(i/length(selectedData));
        
            
        elseif i == 11
            if selectedData(i)
                disp('Loading data from RFID iBracelet ...');
                tmpPath = [ matPath 'rfid.mat'];
                if exist(tmpPath, 'file') && rfidLoaded == 0
                    disp(['Found Matlab data file with RFID data, named : ' tmpPath])
                    userAnswer = questdlg( ['Found Matlab data file with RFID data named : ' tmpPath '. Do you want to load it?'], 'Data Load Results','Yes','No', 'Cancel','Yes');
                    if strcmp(userAnswer, 'Yes')
                        load(tmpPath);
                        rfid.File = paths{i};
                        rfidLoaded = 1;
                    elseif strcmp(userAnswer, 'Cancel')
                        break
                    end
                end
                if rfidLoaded == 0
                    %paths{i}=preSyncRFID(paths{i});
                    rfid.File = paths{i};
                    [rfid.Data, rfid.timing] = readRFIDData(rfid.File);
                    msgDisp = 'RFID : OK';
                end
            else
                msgDisp = 'RFID Not loaded'; 
            end
            disp(msgDisp);

        elseif i == 12
            if selectedData(i)
                disp(['Loading data from eWatch ...']);

                tmpPath = [ matPath 'ewatch.mat'];
                if exist(tmpPath, 'file') && ewatchLoaded == 0
                    disp(['Found Matlab data file with eWatch data, named : ' tmpPath])
                    userAnswer = questdlg( ['Found Matlab data file with eWatch data named : ' tmpPath '. Do you want to load it?'], 'Data Load Results','Yes','No', 'Cancel','Yes');
                    if strcmp(userAnswer, 'Yes')
                        load(tmpPath);
                        ewatch.File = paths{i};
                        ewatchLoaded = 1;
                    elseif strcmp(userAnswer, 'Cancel')
                        break
                    end
                end
                if ewatchLoaded == 0
                    ewatch.File = paths{i};
                    [ewatch.accel_X, ewatch.accel_Y, ewatch.accel_Z, ewatch.light, ewatch.timeSeconds] = readeWatchData(ewatch.File);
                    msgDisp = 'eWatch : OK';
                end
            else
                msgDisp = 'eWatch Not loaded'; 
            end  
            disp(msgDisp);
        end
    end

    waitbar(1);

    allTextTimeStamp = sort(allTextTimeStamp);
    lengthAllCam = length(allTextTimeStamp);

    close(handles_waitLoad);

    for j=1:length(selectedData)
        if selectedData(j) ~= 0
            allowSave = 1;
        end
    end
    
    
catch ME
    close(handles_waitLoad)
    errordlg('Error Loading Data.');
    disp(ME.message)
end

set(hObject, 'Enable', 'on');


% Set control variables ready for playing, just in case Control gui was
% started before LoadFile...
setControlInit();




% --- Executes on button press in checkbox_default.
function checkbox_default_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_default (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_default

global settings

checkbox = get(hObject,'Value');
if checkbox == 1
    set (handles.edit_path_imu_cb, 'Enable', 'off');
    set (handles.edit_path_imu_bt, 'Enable', 'off');
    set (handles.edit_path_cam1, 'Enable', 'off');
    set (handles.edit_path_cam2, 'Enable', 'off');
    set (handles.edit_path_cam3, 'Enable', 'off');
    set (handles.edit_path_cam4, 'Enable', 'off');
    set (handles.edit_path_cam5, 'Enable', 'off');
    set (handles.edit_path_camonboard, 'Enable', 'off');
    set(handles.edit_path_cam_timestamp, 'Enable', 'off');
    set(handles.edit_path_mic, 'Enable', 'off');
    set(handles.edit_path_mocap, 'Enable', 'off');
    set(handles.edit_path_rfid, 'Enable', 'off');
    set(handles.edit_path_ewatch, 'Enable', 'off');
    set(handles.edit_path_mat, 'Enable', 'off');

    mainPath = get(handles.edit_main, 'String');
    setPaths(handles, settings);
    
else
    set (handles.edit_path_imu_cb, 'Enable', 'on');
    set (handles.edit_path_imu_bt, 'Enable', 'on');
    set (handles.edit_path_cam1, 'Enable', 'on');
    set (handles.edit_path_cam2, 'Enable', 'on');
    set (handles.edit_path_cam3, 'Enable', 'on');
    set (handles.edit_path_cam4, 'Enable', 'on');
    set (handles.edit_path_cam5, 'Enable', 'on');
    set (handles.edit_path_camonboard, 'Enable', 'on');
    set(handles.edit_path_cam_timestamp, 'Enable', 'on');
    set(handles.edit_path_mic, 'Enable', 'on');
    set(handles.edit_path_mocap, 'Enable', 'on');
    set(handles.edit_path_rfid, 'Enable', 'on');
    set(handles.edit_path_ewatch, 'Enable', 'on');
    set(handles.edit_path_mat, 'Enable', 'on');
end





% --- Outputs from this function are returned to the command line.
function varargout = LoadFile_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


function edit_main_Callback(hObject, eventdata, handles)
% hObject    handle to edit_main (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_main as text
%        str2double(get(hObject,'String')) returns contents of edit_main as a double


% --- Executes during object creation, after setting all properties.
function edit_main_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_main (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in pushbutton_main.
function pushbutton_main_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_main (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global path
global settings

h = waitbar(0,'Creating default paths...');
path = uigetdir;
waitbar(60/100);
if path~=0
    waitbar(65/100);
    set(handles.edit_main, 'String', path);
    waitbar(80/100);
    if get(handles.checkbox_default, 'Value') == 1
        waitbar(85/100);
        setCamNames(handles, settings);
        waitbar(90/100);
        setPaths(handles, settings);
        waitbar(95/100);
    end
waitbar(100/100);
delete(h);
end




% --- Executes on button press in checkbox_names.
function checkbox_names_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_names (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_names
global settings

setCamNames(handles, settings);




function edit_name_cam1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_name_cam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_name_cam1 as text
%        str2double(get(hObject,'String')) returns contents of edit_name_cam1 as a double


% --- Executes during object creation, after setting all properties.
function edit_name_cam1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_name_cam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_name_cam2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_name_cam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_name_cam2 as text
%        str2double(get(hObject,'String')) returns contents of edit_name_cam2 as a double


% --- Executes during object creation, after setting all properties.
function edit_name_cam2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_name_cam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_name_cam3_Callback(hObject, eventdata, handles)
% hObject    handle to edit_name_cam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_name_cam3 as text
%        str2double(get(hObject,'String')) returns contents of edit_name_cam3 as a double


% --- Executes during object creation, after setting all properties.
function edit_name_cam3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_name_cam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_name_cam4_Callback(hObject, eventdata, handles)
% hObject    handle to edit_name_cam4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_name_cam4 as text
%        str2double(get(hObject,'String')) returns contents of edit_name_cam4 as a double


% --- Executes during object creation, after setting all properties.
function edit_name_cam4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_name_cam4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_name_cam5_Callback(hObject, eventdata, handles)
% hObject    handle to edit_name_cam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_name_cam5 as text
%        str2double(get(hObject,'String')) returns contents of edit_name_cam5 as a double


% --- Executes during object creation, after setting all properties.
function edit_name_cam5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_name_cam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_name_cam6_Callback(hObject, eventdata, handles)
% hObject    handle to edit_name_cam6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_name_cam6 as text
%        str2double(get(hObject,'String')) returns contents of edit_name_cam6 as a
%        double


% --- Executes during object creation, after setting all properties.
function edit_name_cam6_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_name_cam6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_all.
function checkbox_all_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_all (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_alldefault = get(hObject,'Value');

global settings

checkbox = get(hObject,'Value');
if checkbox == 1
    set (handles.checkbox_imu_cb, 'Value', 1.0);
    set (handles.checkbox_cam1, 'Value', 1.0);
    set (handles.checkbox_cam2, 'Value', 1.0);
    set (handles.checkbox_cam3, 'Value', 1.0);
    set (handles.checkbox_cam4, 'Value', 1.0);
    set (handles.checkbox_cam5, 'Value', 1.0);
    set (handles.checkbox_camonboard, 'Value', 1.0);
    set (handles.checkbox_mic, 'Value', 1.0);
    set (handles.checkbox_mocap, 'Value', 1.0);
    if ~settings.pilotTree
        set (handles.checkbox_imu_bt, 'Enable', 'on', 'Value', 1.0);
        set (handles.checkbox_rfid, 'Enable', 'on', 'Value', 1.0);
        set (handles.checkbox_ewatch, 'Enable', 'on', 'Value', 1.0);
    else
        set (handles.checkbox_imu_bt, 'Enable', 'off');
        set (handles.checkbox_rfid, 'Enable', 'off');
        set (handles.checkbox_ewatch, 'Enable', 'off');
    end
    
else
    set (handles.checkbox_imu_cb, 'Value', 0.0);
    set (handles.checkbox_imu_bt, 'Value', 0.0);
    set (handles.checkbox_cam1, 'Value', 0.0);
    set (handles.checkbox_cam2, 'Value', 0.0);
    set (handles.checkbox_cam3, 'Value', 0.0);
    set (handles.checkbox_cam4, 'Value', 0.0);
    set (handles.checkbox_cam5, 'Value', 0.0);
    set (handles.checkbox_camonboard, 'Value', 0.0);
    set (handles.checkbox_mic, 'Value', 0.0);
    set (handles.checkbox_mocap, 'Value', 0.0);
    set (handles.checkbox_rfid, 'Value', 0.0);
    set (handles.checkbox_ewatch, 'Value', 0.0);
end



function edit_path_imu_cb_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_imu_cb as text
%        str2double(get(hObject,'String')) returns contents of edit_path_imu_cb as a
%        double


% --- Executes during object creation, after setting all properties.
function edit_path_imu_cb_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white', 'HorizontalAlignment', 'right');
end


function edit_path_imu_bt_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_bt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_imu_bt as text
%        str2double(get(hObject,'String')) returns contents of edit_path_imu_bt as a double


% --- Executes during object creation, after setting all properties.
function edit_path_imu_bt_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_bt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_path_cam1_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_cam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_cam1 as text
%        str2double(get(hObject,'String')) returns contents of edit_path_cam1 as a double


% --- Executes during object creation, after setting all properties.
function edit_path_cam1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_cam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white', 'HorizontalAlignment', 'right');
end



function edit_path_cam2_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_imu_cb as text
%        str2double(get(hObject,'String')) returns contents of edit_path_imu_cb as a double


% --- Executes during object creation, after setting all properties.
function edit_path_cam2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white', 'HorizontalAlignment', 'right');
end



function edit_path_cam3_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_cam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_cam3 as text
%        str2double(get(hObject,'String')) returns contents of edit_path_cam3 as a double


% --- Executes during object creation, after setting all properties.
function edit_path_cam3_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_cam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white', 'HorizontalAlignment', 'right');
end



function edit_path_cam4_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_imu_cb as text
%        str2double(get(hObject,'String')) returns contents of edit_path_imu_cb as a double


% --- Executes during object creation, after setting all properties.
function edit_path_cam4_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white', 'HorizontalAlignment', 'right');
end



function edit_path_cam5_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_cam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_cam5 as text
%        str2double(get(hObject,'String')) returns contents of edit_path_cam5 as a double


% --- Executes during object creation, after setting all properties.
function edit_path_cam5_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_cam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white', 'HorizontalAlignment', 'right');
end



function edit_path_camonboard_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_imu_cb as text
%        str2double(get(hObject,'String')) returns contents of edit_path_imu_cb as a
%        double


% --- Executes during object creation, after setting all properties.
function edit_path_camonboard_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white', 'HorizontalAlignment', 'right');
end



function edit_path_cam_timestamp_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_cam_timestamp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_cam_timestamp as text
%        str2double(get(hObject,'String')) returns contents of edit_path_cam_timestamp as a double


% --- Executes during object creation, after setting all properties.
function edit_path_cam_timestamp_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_cam_timestamp (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




function edit_path_mic_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_mic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_mic as text
%        str2double(get(hObject,'String')) returns contents of edit_path_mic as a double


% --- Executes during object creation, after setting all properties.
function edit_path_mic_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_mocap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_path_mocap_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_mocap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_mocap as text
%        str2double(get(hObject,'String')) returns contents of edit_path_mocap as a double


% --- Executes during object creation, after setting all properties.
function edit_path_mocap_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_mocap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_path_mat_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_mat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_mat as text
%        str2double(get(hObject,'String')) returns contents of edit_path_mat as a double


% --- Executes during object creation, after setting all properties.
function edit_path_mat_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_mat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_path_rfid_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_rfid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_rfid as text
%        str2double(get(hObject,'String')) returns contents of edit_path_rfid as a double


% --- Executes during object creation, after setting all properties.
function edit_path_rfid_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_rfid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


function edit_path_ewatch_Callback(hObject, eventdata, handles)
% hObject    handle to edit_path_ewatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_path_ewatch as text
%        str2double(get(hObject,'String')) returns contents of edit_path_ewatch as a double


% --- Executes during object creation, after setting all properties.
function edit_path_ewatch_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_path_ewatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkbox_imu_cb.
function checkbox_imu_cb_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_imu_cb (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_imu_cb


% --- Executes on button press in checkbox_imu_bt.
function checkbox_imu_bt_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_imu_bt (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_imu_bt



% --- Executes on button press in checkbox_cam1.
function checkbox_cam1_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_cam1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_cam1


% --- Executes on button press in checkbox_cam2.
function checkbox_cam2_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_cam2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_cam2


% --- Executes on button press in checkbox_cam3.
function checkbox_cam3_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_cam3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_cam3


% --- Executes on button press in checkbox_cam4.
function checkbox_cam4_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_cam4 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_cam4


% --- Executes on button press in checkbox_cam5.
function checkbox_cam5_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_cam5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_cam5


% --- Executes on button press in checkbox_camonboard.
function checkbox_camonboard_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_camonboard (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_camonboard


% --- Executes on button press in checkbox_mic.
function checkbox_mic_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_mic (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_mic


% --- Executes on button press in checkbox_mocap.
function checkbox_mocap_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_mocap (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_mocap


% --- Executes on button press in checkbox_rfid.
function checkbox_rfid_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_rfid (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_rfid



% --- Executes on button press in checkbox_ewatch.
function checkbox_ewatch_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_ewatch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_ewatch



% --- Executes on button press in checkbox_mat.
function checkbox_mat_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_mat (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_mat


% --------------------------------------------------------------------
function menu_settings_Callback(hObject, eventdata, handles)
% hObject    handle to menu_settings (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function menu_settings_options_Callback(hObject, eventdata, handles)
% hObject    handle to menu_settings_options (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

h_set_fig = figure(load_settings_gui);
