function sampleMocap = getSampleMocap(currentTime, handle_control)
global mocap
global lastMocapSample


currentSecond = timestamp2sec(currentTime);

sampleMocap = lastMocapSample;

if mocap.timing(sampleMocap)- currentSecond <0
    sampleMocap = sampleMocap + find(mocap.timing(sampleMocap:end) - currentSecond >=0, 1);
    if isempty(sampleMocap)
        sampleMocap = length(mocap.timing);
    end
elseif mocap.timing(sampleMocap)- currentSecond >0
    sampleMocap = find(currentSecond - mocap.timing(1:sampleMocap)  <=0, 1);
    if isempty(sampleMocap)
        sampleMocap = 1;
    end
end

offset = round(str2double(get(handle_control.edit_offset_mocap, 'String')));
if isnan(offset)
    stopPlay(handle_control);
    errordlg('There is not a number in the offset box', 'Error: Offset', 'modal');
    return
end

if ((sampleMocap + offset) >= 1) && ((sampleMocap + offset) <= length(mocap.timing))
    sampleMocap = sampleMocap + offset;
elseif (sampleMocap + offset) < 1
    sampleMocap = 1;
elseif (sampleMocap + offset) >= length(mocap.timing)
    sampleMocap = length(mocap.timing);
end   

lastMocapSample = sampleMocap;
