
function labels = showLabels(handles, currentLabel, currentLabelStr, labels, allLabel)
% This function update the labels with "currentLabel" and the listbox with
% "currentLabelStr" and display the updated list in the listbox


% If a new label (really new or a modified one) is being add to the list
if ~isempty(currentLabel) && ~isempty(allLabel)
    
    % Check if there are more than one label in the list
    if iscell(allLabel)
        inc = strcmp(currentLabelStr, {allLabel{:}});
        
	% or if currently there is only one 
    else
        inc = strcmp(currentLabelStr, {allLabel});
    end
    
    % Check that there is not any label exactly similar in the listbox
    if isempty(find(inc, 1))
        
        % Update the labels with the new one
        labels(size(labels,1)+1,:) = currentLabel;
        % Sort the labels starting from the first one
        labels = sortrows(labels, 1);
        
        % For each label copy all its fields in one string
        for i = 1 : size(labels, 1)
            allLabel{i} = [labels{i, 1} labels{i, 2} labels{i, 3}];
        end
    end
    
    % Display the string of each label in the listbox
    set(handles.listbox_labels, 'String', allLabel);
    
elseif isempty(currentLabel) && ~isempty(allLabel)
    % This case could happen when removing items of the list because
    % currentLabel is empty. In case last item has been removed the size of
    % the list have to be changed:
    set(handles.listbox_labels,'Value',size(allLabel ,1))
    set(handles.listbox_labels, 'String', allLabel);

elseif ~isempty(currentLabel) && isempty(allLabel)
    set(handles.listbox_labels, 'String', currentLabelStr);
    labels = currentLabel;

else
    set(handles.listbox_labels, 'String', allLabel);
end
