
function each_handle_camera = initDisplay(whatData, counter, handles)

global allTextTimeStamp
global whatShow
global hand
global dispInitialized

whatShow.imu_cb = 0;
whatShow.imu_bt = 0;
whatShow.Cams = 0;
whatShow.Audio = 0;
whatShow.Mocap = 0;
whatShow.rfid = 0;
whatShow.ewatch = 0;

hand = startGui(whatData(1), whatData(2));

% Figure out which sensors will be displayed
if whatData(1) ~= 0
    whatShow.imu_cb = 1;
end
if whatData(2) ~= 0
    whatShow.imu_bt = 1;
end
% If data from sensors are loaded ...
if whatShow.imu_cb
    typeImu = 'imu_cb';
elseif whatShow.imu_bt
    typeImu = 'imu_bt';
end
if whatShow.imu_cb || whatShow.imu_bt
    showSensorsData (typeImu, 1);
    dispInitialized = 1;
    sampleSensors = getContSampleIMU(allTextTimeStamp{counter}, handles, typeImu);
    markAxesIMU(sampleSensors,typeImu, handles)
end

if find(whatData(3:8) ~= 0)
    % If video from cameras is loaded ...
    whatShow.Cams = 1;
    dispInitialized =1;
    each_handle_camera = hand.h_cam;
end

if find(whatData(9:13) ~= 0)
    % If audio data is loaded ...
    whatShow.Audio = 1;
    showAudioData (1);
    dispInitialized =1;
    sampleAudio = getSampleAudio(allTextTimeStamp{counter}, 1, handles);
    markSampleAudio(sampleAudio, handles);
end

if whatData(14) == 1
    % If MoCap data is loaded ...
    whatShow.Mocap = 1;
    dispInitialized =1;
end

if whatData(15) == 1
    % If RFID data is loaded ...
    whatShow.rfid = 1;
    dispInitialized =1;
end


if whatData(16) == 1
    % If eWatch data is loaded ...
    whatShow.ewatch = 1;
    dispInitialized =1;
    showeWatchData(handles,1);
    sampeWatch = getSampeWatch(allTextTimeStamp{counter}, handles);
    markSampeWatch(sampeWatch, handles);
end

playData(whatData, whatShow, each_handle_camera, handles, counter);



