function hand = startGui (show_imu_cb, show_imu_bt)

global settings

global imu_cb
global imu_bt

%scrsz = get(0,'ScreenSize');
%scrsz = [1 1 16*88 9*88];
scrsz = [1 1 1376 774]; %ratio 16/9

hand.h_fig = figure('Visible','off','Units', 'pixels', 'Position', [0 0 scrsz(3) scrsz(4) ], 'MenuBar','none','ToolBar','none');
hand.h_z = zoom(hand.h_fig);
set(hand.h_z,'Motion','horizontal','Enable','on');
hand.h_r = rotate3d(hand.h_fig);
set(hand.h_r, 'RotateStyle', 'orbit');


hand.h_cam = zeros(1,6);
for i=1:3
    hand.h_cam(i) = axes('Units', 'pixels','position',[round((i-1)*scrsz(4)/4)*1024/768 scrsz(4)/2 ...
        round(scrsz(4)/4)*1024/768 round(scrsz(4)/4)], 'visible', 'off'); 
end

for i=1:3
    hand.h_cam(i+3) = axes('Units', 'pixels','position',[round((i-1)*scrsz(4)/4)*1024/768 scrsz(4)/2+round(scrsz(4)/4) ...
        round(scrsz(4)/4)*1024/768 round(scrsz(4)/4)], 'visible', 'off'); 
end

hand.h_imu = zeros(1,3);
for i=1:3
    hand.h_imu(i) = axes('Units', 'pixels','position',[0 round(scrsz(4)/2/3*(i-1)) ...
        round(scrsz(3)/2) round(scrsz(4)/2/3)], 'visible', 'off'); 
end


hand.h_audio = axes('Units', 'pixels','position',[round(scrsz(3)/2) round(scrsz(4)/2/3) ...
    round(scrsz(3)/2) round(scrsz(4)/3)], 'visible', 'off');

hand.h_ewatch = axes('Units', 'pixels','position',[round(scrsz(3)/2) 0 ...
    round(scrsz(3)/2) round(scrsz(4)/2/3)], 'visible', 'off');


hand.h_mocap = axes('Units', 'pixels','position', [round(3*scrsz(4)/4)*1024/768 scrsz(4)/2 ...
        scrsz(3)-3*round(scrsz(4)/4)*1024/768 round(scrsz(4)/2)], 'visible', 'off');
setAllowAxesZoom(hand.h_z,hand.h_mocap,false);
%setAllowAxesRotate(hand.h_r,hand.h_mocap,true);


hand.h_time = uicontrol('Style', 'edit', 'string' ,'00:00:00.000','position',[round(.85*scrsz(3)) round(.5*scrsz(4)) ...
    round(.16*scrsz(3)) round(.033*scrsz(4))], 'FontUnits' ,'normalized', 'FontSize', 0.8, 'ForegroundColor',[1 0 0], 'Enable', 'on');

hand.h_rfid = uicontrol('Style', 'edit', 'string' ,'RFID tags','position',[round(.85*scrsz(3)) round(.5*scrsz(4)+.033*scrsz(4)) ...
    round(.16*scrsz(3))  round(.033*scrsz(4))], 'FontUnits' ,'normalized', 'FontSize', 0.75, 'ForegroundColor',[0 0.5 0], 'Enable', 'on');

hand.h_label = uicontrol('Style', 'edit', 'string' ,'Labels','position',[round(.85*scrsz(3)) round(scrsz(4)/2/3)+round(.033*scrsz(4)) ...
    round(.16*scrsz(3))  round(.033*scrsz(4))], 'FontUnits' ,'normalized', 'FontSize', 0.8, 'ForegroundColor',[0 0 0.5], 'Enable', 'on');
set(hand.h_label, 'visible', 'off');


hand.imuListDesc = {};
hand.imuSel = [];
if show_imu_cb
    hand.imuListDesc = {imu_cb.id{:}};
end
if ~settings.pilotTree && show_imu_bt
    hand.imuListDesc = {hand.imuListDesc{:}, imu_bt.id{:}};
end

imu_val = 5;
if size(hand.imuListDesc,2) < 5
    imu_val = 1;
end
hand.h_imu_list = uicontrol('Style', 'popupmenu', 'String', hand.imuListDesc, 'Value', imu_val, 'BackGroundColor', [236 246 134]./255, ...
    'Position', [round(scrsz(3)/4-.1*scrsz(3)) round(scrsz(4)/2-.025*scrsz(4)) round(.1*scrsz(3)) round(.025*scrsz(4))]);
if isempty(hand.imuListDesc)
    set(hand.h_imu_list, 'Enable', 'off');
else
    hand.imuSel = 1;
end


hand.audioListDesc = {'Mic Ceiling', 'Mic Freezer', 'Mic Cooker', 'Mic Sink', 'Mic Cupboard'};
hand.h_audio_list = uicontrol('Style', 'popupmenu', 'String', hand.audioListDesc, 'BackGroundColor', [236 246 134]./255,...
    'Position', [round(3*scrsz(3)/3-.07*scrsz(3)) round(scrsz(4)/2-.025*scrsz(4)) round(.07*scrsz(3)) round(.025*scrsz(4))]);
if isempty(hand.audioListDesc)
    set(hand.audioListDesc, 'Enable', 'off');
else
    hand.audioSel = 1;
end

hand.eWatchlist = {'Accelerometer','Light'};
hand.h_ewatch_list = uicontrol('Style','popupmenu','String',hand.eWatchlist,'BackGroundColor', [236 246 134]./255,...
 'Position', [round(3*scrsz(3)/3-.07*scrsz(3)) 0 round(scrsz(3)/2*0.15) round(scrsz(4)/2/3)]);
if isempty(hand.eWatchlist)
    set(hand.eWatchlist, 'Enable', 'off');
else
    hand.ewatchSel = 1;
end


set(hand.h_fig,'Visible','on');


