function setDeafaultPaths(mainPath, handles, settings)
% Writes default paths on handles coming from default path

dataDir = dir(mainPath);

% All default directories should hang from the main path
if ~isempty(dataDir)

    % Wired IMU Microstrain 3DMGX1 sensors
    i =1;
    while (isempty(strfind(dataDir(i).name, '3DMGX1')) && isempty(strfind(dataDir(i).name, '3dmgx1')) || ~dataDir(i).isdir) && i < size({dataDir.name},2)
        i=i+1; 
    end
    if ~(isempty(strfind(dataDir(i).name, '3DMGX1')) && isempty(strfind(dataDir(i).name, '3dmgx1')) || ~dataDir(i).isdir)
        pathFile = strcat(mainPath, dataDir(i).name, filesep);
        set (handles.edit_path_imu_cb, 'String', pathFile);
    else
        set (handles.edit_path_imu_cb, 'String', 'Directory not found');
        %disp(['IMU Microstrain 3DMGX1 directory not found in:' mainPath]);
        %errdlg();
    end
    
    % Bluetooth IMU Sparkfun 6DOFv4 sensors
    i =1;
    while (isempty(strfind(dataDir(i).name, '6DOFv4')) && isempty(strfind(dataDir(i).name, '6dofv4')) || ~dataDir(i).isdir) && i < size({dataDir.name},2)
        i=i+1; 
    end
    if ~(isempty(strfind(dataDir(i).name, '6DOFv4')) && isempty(strfind(dataDir(i).name, '6dofv4')) || ~dataDir(i).isdir)
        pathFile = strcat(mainPath, dataDir(i).name, filesep);
        set (handles.edit_path_imu_bt, 'String', pathFile);
    else
        set (handles.edit_path_imu_bt, 'String', 'Directory not found');
        %checkVal  disp(['IMU Sparkfun 6DOFv4 directory not found in:' mainPath]);
        %errdlg();
    end
    
    
    % Cameras timestamp and root-images ('pathFile') directories
    if ~settings.pilotTree
        % In main dataset it is in the main path or in Video folder (S28 to
        % S55)
        i=1;
        while (isempty(strfind(dataDir(i).name, 'Video')) && isempty(strfind(dataDir(i).name, 'video')) || ~dataDir(i).isdir) && i < size({dataDir.name},2)
            i=i+1; 
        end
        if ~(isempty(strfind(dataDir(i).name, 'Video')) && isempty(strfind(dataDir(i).name, 'video')) || ~dataDir(i).isdir)
            pathFile = strcat(mainPath, dataDir(i).name, filesep);
        else
            %disp(['Video folder directory not found in:' mainPath]);
            %errdlg();
            %pathFile = strcat(mainPath);
            pathFile = mainPath;
        end
        
        %pathFile is root or Video_timestamp
        set (handles.edit_path_cam_timestamp, 'String', pathFile); 
    else
        % In pilot dataset it is 
        set (handles.edit_path_cam_timestamp, 'String', strcat(mainPath, 'timestamps', filesep));
        pathFile = strcat(mainPath, 'cpImg', filesep);
    end
    % Cameras 1 to 6 (in pilot data set cam6 is called 'Onboard')
    nameCam1 = get (handles.edit_name_cam1, 'String');
    nameCam2 = get (handles.edit_name_cam2, 'String');
    nameCam3 = get (handles.edit_name_cam3, 'String');
    nameCam4 = get (handles.edit_name_cam4, 'String');
    nameCam5 = get (handles.edit_name_cam5, 'String');
    nameCamOnBoard = get (handles.edit_name_cam6, 'String');
    set (handles.edit_path_cam1, 'String', strcat(pathFile, nameCam1, filesep));
    set (handles.edit_path_cam2, 'String', strcat(pathFile, nameCam2, filesep));
    set (handles.edit_path_cam3, 'String', strcat(pathFile, nameCam3, filesep));
    set (handles.edit_path_cam4, 'String', strcat(pathFile, nameCam4, filesep));
    set (handles.edit_path_cam5, 'String', strcat(pathFile, nameCam5, filesep));
    set (handles.edit_path_camonboard, 'String', strcat(pathFile, nameCamOnBoard, filesep));
    

    % Audio
    %pathFile = strcat(mainPath, 'audio', filesep);
    %set(handles.edit_path_mic, 'String', strcat(pathFile, 'AudioTrack.wav'));
    i =1;
        while (isempty(strfind(dataDir(i).name, 'Audio')) && isempty(strfind(dataDir(i).name, 'audio')) || ~dataDir(i).isdir) && i < size({dataDir.name},2)
            i=i+1; 
        end
        if ~(isempty(strfind(dataDir(i).name, 'Audio')) && isempty(strfind(dataDir(i).name, 'audio')) || ~dataDir(i).isdir)
            %path of audio folder
            pathFile = strcat(mainPath, dataDir(i).name, filesep);

            dataDirAudio = dir(pathFile);
            %we search the audiotrack.wav file
            j=1;
            while (isempty(strfind(dataDirAudio(j).name, 'Audio Track.wav')) && isempty(strfind(dataDirAudio(j).name, 'AudioTrack.wav'))) && j < size({dataDirAudio.name},2)
                j=j+1; 
            end
            if ~isempty(strfind(dataDirAudio(j).name, 'AudioTrack.wav')) || ~isempty(strfind(dataDirAudio(j).name, 'Audio Track.wav'))
                set (handles.edit_path_mic, 'String', strcat(pathFile,dataDirAudio(j).name));
            else
                set (handles.edit_path_mic, 'String', 'File not found');
            end
        else
            set (handles.edit_path_mic, 'String', 'Directory not found');
        end

    % Mocap
    %pathFile = strcat(mainPath, 'mocap', filesep);
    %set(handles.edit_path_mocap, 'String', pathFile);
    i =1;
    while (isempty(strfind(dataDir(i).name, 'mocap')) && isempty(strfind(dataDir(i).name, 'Mocap')) || ~dataDir(i).isdir) && i < size({dataDir.name},2)
        i=i+1; 
    end
    if ~(isempty(strfind(dataDir(i).name, 'mocap')) && isempty(strfind(dataDir(i).name, 'Mocap')) || ~dataDir(i).isdir)
        pathFile = strcat(mainPath, dataDir(i).name, filesep);
        set (handles.edit_path_mocap, 'String', pathFile);
    else
        set (handles.edit_path_mocap, 'String', 'Directory not found');
    end


    % RFID and eWatch are only in main dataset, not in the pilot one
    if ~settings.pilotTree
    
        % RFID
        i =1;
        while (isempty(strfind(dataDir(i).name, 'RFID')) && isempty(strfind(dataDir(i).name, 'rfid')) || ~dataDir(i).isdir) && i < size({dataDir.name},2)
            i=i+1; 
        end
        if ~(isempty(strfind(dataDir(i).name, 'RFID')) && isempty(strfind(dataDir(i).name, 'rfid')) || ~dataDir(i).isdir)
            %path of rfid folder
            pathFile = strcat(mainPath, dataDir(i).name, filesep);

            dataDirRFID = dir(pathFile);
            %we search the rfid file rfid-timestamp.txt
            j=1;
            while (isempty(strfind(dataDirRFID(j).name, 'RFID-')) || isempty(strfind(dataDirRFID(j).name, '-sync'))) && j < size({dataDirRFID.name},2)
                j=j+1; 
            end
            if ~isempty(strfind(dataDirRFID(j).name, 'RFID-')) && ~isempty(strfind(dataDirRFID(j).name, '-sync'))
                set (handles.edit_path_rfid, 'String', strcat(pathFile,dataDirRFID(j).name));
            else
                j=1;
                while (isempty(strfind(dataDirRFID(j).name, 'RFID-')) || isempty(strfind(dataDirRFID(j).name, '-presync'))) && j < size({dataDirRFID.name},2)
                    j=j+1; 
                end
                if ~isempty(strfind(dataDirRFID(j).name, 'RFID-')) && ~isempty(strfind(dataDirRFID(j).name, '-presync'))
                    set (handles.edit_path_rfid, 'String', strcat(pathFile,dataDirRFID(j).name));
                else
                    j=1;
                    while isempty(strfind(dataDirRFID(j).name, 'RFID-')) && j < size({dataDirRFID.name},2)
                        j=j+1; 
                    end
                    if ~isempty(strfind(dataDirRFID(j).name, 'RFID-'))
                        set (handles.edit_path_rfid, 'String', strcat(pathFile,dataDirRFID(j).name));
                    else
                        set (handles.edit_path_rfid, 'String', 'File not found');
                        %disp(['RFID data file not found in:' pathFile]);
                        %errdlg();
                    end
                end
            end
        else
            set (handles.edit_path_rfid, 'String', 'Directory not found');
            %disp(['RFID data file not found in:' mainPath]);
            %errdlg();
        end

        % eWatch
        i =1;
        while (isempty(strfind(dataDir(i).name, 'eWatch')) && isempty(strfind(dataDir(i).name, 'ewatch')) || ~dataDir(i).isdir) && i < size({dataDir.name},2)
            i=i+1; 
        end
        if ~(isempty(strfind(dataDir(i).name, 'eWatch')) && isempty(strfind(dataDir(i).name, 'ewatch')) || ~dataDir(i).isdir)
            pathFile = strcat(mainPath, dataDir(i).name, filesep);
            set (handles.edit_path_ewatch, 'String', pathFile);
        else
            set (handles.edit_path_ewatch, 'String', 'Directory not found');
            %disp(['eWatch directory not found in:' mainPath]);
            %errdlg();
        end
        
    else % ... in case Pilot data set, RFID and eWatch are off
        set (handles.edit_path_rfid, 'Enable', 'off');
        set (handles.edit_path_ewatch, 'Enable', 'off');
    end

    % Once everything is loaded, path where saving data as MATLAB variables
    pathFile = strcat(mainPath, 'matlab', filesep);
    set(handles.edit_path_mat, 'String', pathFile);
end

drawnow % update the display for the user

