function [timeStart, timeStop] = getAudioTimeInit(audioPath)
% Reads timestamps, starttime and endtime

audioTimeFile = [audioPath 'recording-synch.log'];
fid = fopen(audioTimeFile);
if fid~=-1
    strAudioTime = textscan(fid, '%*s %s', 'delimiter', '\t');
    fclose(fid);
    timeStart = timestamp2sec(strAudioTime{1}{1});
    timeStop = timestamp2sec(strAudioTime{1}{2});
    
else % when it is not synchronized yet
    audioTimeFile = [audioPath 'recording.log'];
    fid = fopen(audioTimeFile);
    strAudioTime = textscan(fid, '%*s %*s %*s %*s %*s %*s %*s %s %*s %s', 'HeaderLines', 1);
    fclose(fid);

    usec = sprintf('%0.7f',str2double(strAudioTime{2}{1}(7:end-1))*10^-6);
    timeStart = sprintf('%s.%s', strAudioTime{1}{1}, usec(3:end));
    timeStart = timestamp2sec(timeStart);

    usec = sprintf('%0.7f',str2double(strAudioTime{2}{2}(7:end-1))*10^-6);
    timeStop = sprintf('%s.%s', strAudioTime{1}{2}, usec(3:end));
    timeStop = timestamp2sec(timeStop);
end