
function [textTimeStampCam, num1stFrame, numlastFrame, numFrames]= getCamTimeStamp (pathFile, camFile, cameraName)
% Saves alltimestamps and the number of frames of a camera

fileIsThere = 1;
global mainPath

%   Find out "TSFile":
%       This text file contains all of the Time Stamps associated with
%       each frame recorded
TSFile = strcat(pathFile, 'STime',cameraName,'-time-synch.txt'); 
if ~exist(TSFile, 'file')
    TSFile = strcat(pathFile, 'STime',cameraName,'-time-presynch.txt'); 
    if ~exist(TSFile, 'file')
        fprintf('Cameras are not presyncronized, starting to presynchronize...\n');
        preSyncCameras(mainPath);
        
        % Ask for presynch and call the function passing camera names !!
        
        %TSFile = [pathFile, 'STime',cameraName,'-time.txt']; 
        %if ~exist(TSFile, 'file')
        %    fileIsThere = 0;
        %    error(['Timestamp file: ' TSFile ' not found']);
        %end
    end
end


if fileIsThere
    %   Find out "StartTSFile": 
    %     This text file contains the TimeStamp of the first frame recorded
    %     with this camera. It makes sense in the case we split a video in
    %     images because we need to correlate the line number with the
    %     frame number 
    StartTSFile = strcat(pathFile, 'StartTS',cameraName,'-time.txt'); 
    try
        textStart = textread(StartTSFile, '%*s%s%*s', 'delimiter', '-');
        num1stFrame = str2num(textStart{1});
        numlastFrame = str2num(textStart{2});
    catch ME
        %disp('There is not file indicating begin and end of the movie!!');
        %disp('It should only happen in Debug mode!!');
        num1stFrame = 1;
        numlastFrame = NaN;
    end
    % Get all time stamps from file "TSFile"
    % Necessary to distinguish the Time Stamp format of Onboard camera

    [frames textTimeStampCam] = textread(TSFile, '%s%*s%*s%*s%s');
    if isnan(numlastFrame)
       numlastFrame = length(textTimeStampCam); 
    end
    textTimeStampCam = {textTimeStampCam{num1stFrame : numlastFrame}};
    
    numFrames = zeros(size(textTimeStampCam,2),1);
    for k = 1 : size(textTimeStampCam, 2)
        textTimeStampCam{k} = strrep(textTimeStampCam{k}, ':', '_');
        textTimeStampCam{k}(9) = '_';
        [token, remain] =strtok(frames(k), ':');
        numFrames(k) = str2double(remain{1}(2:end));

        % Patch for solving the bug in old videos when less  4 decimals are
        % added to the TimeStamp in "textTS" File.
        if (length(textTimeStampCam{k}) < 15)
            trunc = 15 - length(textTimeStampCam{k});
            for i = 5-trunc+1 : 5
                temp = strcat('0', textTimeStampCam{k}(length(textTimeStampCam{k})- (5-trunc) : length(textTimeStampCam{k})));
                textTimeStampCam{k} = strcat(textTimeStampCam{k}(1: length(textTimeStampCam{k})-(5-trunc+1) ), temp);
            end
        end
    end

end
