
function [eachDataIMU, timeStampIMU, timeString, numSensorFiles, id] = getIMUData(IMUPath)
% Saves the information of the IMUs
global settings

eachDataIMU = {};
timeStampIMU = [];
timeString = {};
id = {};

fileNames = dir(IMUPath);
numSensorFiles = 0;
syncIds = cell(length({fileNames.name}),1);

k=0;
for j=1:length(fileNames)    
    loadThis = 0;
    IMUFile = [IMUPath fileNames(j).name];
    syncIds{j} = strtok(IMUFile(find(IMUFile == filesep, 1, 'last')+1:end),'_');
    if ~isdir(IMUFile) 
        if ~isempty(strfind(IMUFile, '-time-synch.txt')) || ...
                ( isempty(strfind(IMUFile, '-time-synch.txt')) && ~isempty(strfind(IMUFile, '-time.txt')) ...
                    && isempty(strmatch(syncIds{j}, {syncIds{1:j-1}} , 'exact')) )
            if ~settings.all_imu 
                if ~isempty(strmatch(syncIds{j}, settings.imuForSync, 'exact'))
                    loadThis = 1;
                end
            else
                loadThis = 1;            
            end
        end
    end
    if loadThis
        k=k+1;
        disp(['Reading file: ' IMUFile]);
        id{k} =syncIds{j};
        fid = fopen(IMUFile);
        strDataIMU = textscan(fid, '%f %f %f %f %f %f %f %f %f %*s %s', 'HeaderLines', 2);
        fclose(fid);
        dataIMU = zeros (size(strDataIMU{1},1),size(strDataIMU,2));
%       for i = 1 : size(strDataIMU,2)-1
%           dataIMU(:,i) = str2double(strDataIMU{i});
%       end
        for i=1:9
            dataIMU(:,i) = strDataIMU{i};
        end
        
        
        dataIMU(:,size(strDataIMU,2))= timestamp2sec(strDataIMU{size(strDataIMU, 2)});
        timeString{k} = strDataIMU{size(strDataIMU, 2)};
        clear strDataIMU
        startTime(k) = dataIMU(1, size(dataIMU,2));
        stopTime(k) = dataIMU(size(dataIMU,1), size(dataIMU,2));  
        eachDataIMU{k} = dataIMU;
        numSensorFiles = numSensorFiles +1;
    end
end
%fprintf('Start time: %s, Stop time: %s.\n',startTime, stopTime);



% Adjust data from different sensors to plot then
if ~isempty(eachDataIMU)
   
    % As we want to use only one timestamp for all the sensors, get only
    % samples which are defined for all sensors.
    maxStartTime = max(startTime);
    minStopTime = min(stopTime);

    for j=1:numSensorFiles
        halfPeriod = 0.5* (eachDataIMU{j}(2, size(eachDataIMU{j}, 2)) - eachDataIMU{j}(1, size(eachDataIMU{j}, 2)));
        usefulDown = find(eachDataIMU{j}(:, size(eachDataIMU{j}, 2)) >= maxStartTime - halfPeriod);
        if ~isempty(usefulDown)
            usefulDown = usefulDown(1);
            if usefulDown > 1
                eachDataIMU{j}(1:usefulDown(1) -1, :) = [];
                timeString{j}(1:usefulDown(1) -1, :) = [];
            end
        end
        usefulUp = find(eachDataIMU{j}(:, size(eachDataIMU{j}, 2)) <= minStopTime + halfPeriod);
        if ~isempty(usefulUp)
            usefulUp = usefulUp(length(usefulUp));
            if usefulUp < size(eachDataIMU{j},1)
                eachDataIMU{j}(usefulUp(length(usefulUp)) +1:size(eachDataIMU{j},1), :) = [];
                timeString{j}(usefulUp(length(usefulUp)) +1:size(eachDataIMU{j},1), :) = [];
            end
        end
        nRows(j) = size(eachDataIMU{j}, 1);
        
        timeStampIMU = eachDataIMU{j}(:,size(eachDataIMU{j},2));
    	eachDataIMU{j}(:, size(eachDataIMU{j}, 2))= [];
    end

    % if any sensor still has less samples than others, concatenate with zeros
    maxSize = max(nRows);
    for j = 1:numSensorFiles
        sizeThis = size(eachDataIMU{j});
        if  sizeThis(1) < maxSize
            eachDataIMU{j} = [eachDataIMU{j}(1:sizeThis(1), :) ; ...
                zeros(maxSize-sizeThis(1), sizeThis(2))];
        end
    end
    
	
    
end

