
function [wsDOF, wsFeat, wsPart, paraF] = readDataMOCAP(path)


asfname = [];
amcname = [];
% load mocap data from amc file
dataDir = dir(path);
for i =1:size({dataDir.name},2)
    if ~isempty(regexpi(dataDir(i).name, '\.asf')) && ~isDir(dataDir(i).name)
        asfname = strcat(path, dataDir(i).name);
    end
    if ~isempty(regexpi(dataDir(i).name, '\.amc')) && ~isDir(dataDir(i).name)
        amcname = strcat(path, dataDir(i).name);
    end
end

if ~isempty(amcname) && ~isempty(asfname)
    paraF = getMOCParaF('kitchen');
    wsDOF = mocDOF(amcname, asfname, paraF);
    wsFeat = mocFeat(wsDOF, paraF);
    wsPart = mocPart(wsFeat, paraF);
else
	errordlg('MOCAP File is not valid');
end