function [data, timing] = readRFIDData(rfidPath)
%reads the RFID data

global mainPath;

data = {};
timing = [];

rfidFile = [strfind(rfidPath, 'rfid') strfind(rfidPath, 'RFID')];

if ~isempty(rfidFile)
    if isempty(findstr(rfidPath,'-presync')) && isempty(findstr(rfidPath,'-sync'))
       %fprintf('Presynchronized RFID not found, starting to presynchronize...\n');
       %rfidPath=preSyncRFID(rfidPath); 
       %fprintf('RFID presynchronized OK!\n');
    end
    
    
    try 
        disp(['Reading file: ' rfidPath(rfidFile(1):end)]);
        fid = fopen(rfidPath);
        strdata = textscan(fid, '%*s %s %s');
        fclose(fid);
        data = strdata{2};
        timing = timestamp2sec(strdata{1}(1:end-1));
    catch
        disp(['ERROR Reading file: ' rfidFile])
        errordlg('RFID File is not valid');
    end
end

