function timing = readTimeMOCAP(path, len)
% timing
global mainPath;


timefile = [path 'mocapTime-sync.txt'];
if ~exist(timefile, 'file') 
    timefile = [path 'mocapTime.txt'];
    if ~exist(timefile, 'file') 
        mocapTimeGenerator(mainPath); 
    end
end
if exist(timefile, 'file') 
    fprintf('Reading %s...\n',timefile);
    fid = fopen(timefile);
    strs = textscan(fid, '%*s %s', 'HeaderLines', 0);
    fclose(fid);
   
    timeStart = timestamp2sec(strs{1}{1});
    [period, frameRate] = getPeriod(strs{1}{2},strs{1}{1})
    %period=1/120    
    timing = zeros(len,1);

    for i=1:length(timing)
        timing(i) = timeStart + period*i;
    end

else
    errordlg('File is not valid');
end

function [framePeriod, frameRate] = getPeriod(sysTimeII, sysTimeI)
% framePeriod in 1/10*microseconds

hhII = str2double(sysTimeII(1:2));
mmII = str2double(sysTimeII(4:5));
ssII = str2double(sysTimeII(7:8));
uuII = str2double(sysTimeII(10:16));

hhI = str2double(sysTimeI(1:2));
mmI = str2double(sysTimeI(4:5));
ssI = str2double(sysTimeI(7:8));
uuI = str2double(sysTimeI(10:16));


uuII = uuII + 10^7*ssII + 60*10^7*mmII + 60*60*10^7*hhII;
uuI = uuI + 10^7*ssI + 60*10^7*mmI + 60*60*10^7*hhI;

framePeriod = (uuII - uuI)/10^7;
frameRate = round(1/framePeriod);

