function [accel_X, accel_Y, accel_Z, light, timing] = readeWatchData(ewatchPath)
% stores the eWatch data

global settings

accel_X = [];
accel_Y = [];
accel_Z = [];
light = [];
timing =[];


dataDir = dir(ewatchPath);
if ~isempty(dataDir)
    i =1;
    while (isempty(strfind(dataDir(i).name, 'eWatch_')) || isempty(strfind(dataDir(i).name, 'sync'))) && i < size({dataDir.name},2)
        i=i+1; 
    end
    if ~((isempty(strfind(dataDir(i).name, 'eWatch_')) || isempty(strfind(dataDir(i).name, 'sync'))))
        ewatchFile = strcat(ewatchPath, dataDir(i).name);
    else
        i =1;
        while (isempty(strfind(dataDir(i).name, 'eWatch_'))) && i < size({dataDir.name},2)
            i=i+1; 
        end
        if ~((isempty(strfind(dataDir(i).name, 'eWatch_'))))
            ewatchFile = strcat(ewatchPath, dataDir(i).name);
        else
            disp(['eWatch synch file not found in:' mainPath]);
            errdlg(['eWatch synch file not found in:' mainPath]);
        end
    end
end

%ewatchFile = [strfind(ewatchPath, 'eWatch') strfind(ewatchPath, 'eWatch')];
if ~isempty(ewatchFile)
    try 
        disp(['Reading start tine from file: ' ewatchFile]);
        fid = fopen(ewatchFile);
        startTime = fgetl(fid);
        fclose(fid);
        startTime = timestamp2sec([startTime(1:end) '0000']);
        fid = fopen([ewatchPath 'AccX.txt']);
        accel_X = textscan(fid, '%f');
        fclose(fid);
        fid = fopen([ewatchPath 'AccY.txt']);
        accel_Y = textscan(fid, '%f');
        fclose(fid);
        fid = fopen([ewatchPath 'AccZ.txt']);
        accel_Z = textscan(fid, '%f');
        fclose(fid);
        fid = fopen([ewatchPath 'Light.txt']);
        light = textscan(fid, '%f');
        fclose(fid);
        
        timing = zeros(length(light{1}),1);
        for i=1:length(timing)
            timing(i) = startTime + settings.ewatchperiod*(i-1);
        end

    catch ME
        disp(['ERROR Reading file: ' ewatchFile])
        errordlg('eWatch file is not valid');
    end
end