function varargout = load_settings_gui(varargin)
% LOAD_SETTINGS_GUI M-file for load_settings_gui.fig
%      LOAD_SETTINGS_GUI, by itself, creates a new LOAD_SETTINGS_GUI or raises the existing
%      singleton*.
%
%      H = LOAD_SETTINGS_GUI returns the handle to a new LOAD_SETTINGS_GUI or the handle to
%      the existing singleton*.
%
%      LOAD_SETTINGS_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in LOAD_SETTINGS_GUI.M with the given input arguments.
%
%      LOAD_SETTINGS_GUI('Property','Value',...) creates a new LOAD_SETTINGS_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before load_settings_gui_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to load_settings_gui_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help load_settings_gui

% Last Modified by GUIDE v2.5 07-Jul-2009 09:13:51

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @load_settings_gui_OpeningFcn, ...
                   'gui_OutputFcn',  @load_settings_gui_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before load_settings_gui is made visible.
function load_settings_gui_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to load_settings_gui (see VARARGIN)

% Choose default command line output for load_settings_gui
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes load_settings_gui wait for user response (see UIRESUME)
% uiwait(handles.figure1);
% Some global constants as settings
global settings

set(handles.checkbox_imu_all, 'Value', settings.all_imu);
if settings.all_imu == 0
    allimu= 'on';
else
    allimu= 'off';
end
set(handles.edit_imu_cb_sync, 'String', settings.imuForSync{1}, 'enable', allimu);
set(handles.edit_imu_bt_sync, 'String', settings.imuForSync{2}, 'enable', allimu);
set(handles.edit_decimate_audio_factor, 'String', num2str(settings.audioDecimateFactor));
set(handles.checkbox_pilot_tree, 'Value', settings.pilotTree);



% --- Outputs from this function are returned to the command line.
function varargout = load_settings_gui_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in checkbox_imu_all.
function checkbox_imu_all_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_imu_all (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_imu_all
global settings

settings.all_imu = get(hObject, 'Value');
if settings.all_imu
    set(handles.edit_imu_cb_sync, 'enable', 'off');
    set(handles.edit_imu_bt_sync, 'enable', 'off');
else
    set(handles.edit_imu_cb_sync, 'enable', 'on');
    set(handles.edit_imu_bt_sync, 'enable', 'on');    
end

function edit_decimate_audio_factor_Callback(hObject, eventdata, handles)
% hObject    handle to edit_decimate_audio_factor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_decimate_audio_factor as text
%        str2double(get(hObject,'String')) returns contents of edit_decimate_audio_factor as a double

global settings

decimateFactor = str2double(get(hObject, 'String'));
if ~isnan(decimateFactor) && decimateFactor > 0
    settings.settings.audioDecimateFactor = round(decimateFactor);
end

% --- Executes during object creation, after setting all properties.
function edit_decimate_audio_factor_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_decimate_audio_factor (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in checkbox_pilot_tree.
function checkbox_pilot_tree_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_pilot_tree (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_pilot_tree
global settings

settings.pilotTree = get(hObject, 'Value');

function edit_imu_cb_sync_Callback(hObject, eventdata, handles)
% hObject    handle to edit_imu_cb_sync (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_imu_cb_sync as text
%        str2double(get(hObject,'String')) returns contents of edit_imu_cb_sync as a double

% --- Executes during object creation, after setting all properties.
function edit_imu_cb_sync_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_imu_cb_sync (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function edit_imu_bt_sync_Callback(hObject, eventdata, handles)
% hObject    handle to edit_imu_bt_sync (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_imu_bt_sync as text
%        str2double(get(hObject,'String')) returns contents of edit_imu_bt_sync as a double

% --- Executes during object creation, after setting all properties.
function edit_imu_bt_sync_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_imu_bt_sync (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes on button press in checkbox_audio_all.
function checkbox_audio_all_Callback(hObject, eventdata, handles)
% hObject    handle to checkbox_audio_all (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkbox_audio_all
global settings

settings.all_audio = get(hObject, 'Value');

function edit_ewatch_fs_Callback(hObject, eventdata, handles)
% hObject    handle to edit_ewatch_fs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_ewatch_fs as text
%        str2double(get(hObject,'String')) returns contents of edit_ewatch_fs as a double

global settings

ewatchperiod = str2double(get(hObject, 'String'));
if ~isnan(ewatchperiod) && ewatchperiod > 0
    settings.settings.ewatchperiod = ewatchperiod;
end

% --- Executes during object creation, after setting all properties.
function edit_ewatch_fs_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_ewatch_fs (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


