function [vels, angs] = direX(X, varargin)
% Estimate the direction of the given curve in the head area.

n = size(X, 2);
[angs, vels] = zeross(1, n);
for i = 2 : n
    x1 = X(:, i - 1); x2 = X(:, i);
    vels(i) = sqrt((x1 - x2)' * (x1 - x2));
    angs(i) = atan2(x2(2) - x1(2), x2(1) - x1(1));
end
angs(1) = angs(2);
vels(1) = vels(2);



