function X = genCurve(varargin)
% Generate the curve.
% Input
%   varargin
%     type    -  curve type, {'l'} | 's' | 'o', 'l' -> line, 's' -> S type, 'o' - circle
%     n       -  sampling density, {10000}
% Output
%   polyfun   -  curve function

type = ps(varargin, 'type', 'l');
n = ps(varargin, 'n', 10000);

X = zeros(2, n);

if strcmp(type, 'l')
    x = [-1 -.7 -.5 -.2  0  .1  .3  .7  1];
    y = [ 0  .1  .2  .1 .15 .17  0 -.2  0];
    m = 1;
    
elseif strcmp(type, 's')
    x = [0  .2 .4 .50 .8   1];
    y = [0 -.1  0 .15 .3 .25];
    m = 4;
    
    
elseif strcmp(type, 'o')
    deg = linspace(0, pi * 2, n);
    rad = 1;
    X = [cos(deg); sin(deg)] * rad;
    return;
end

polyfun = polyfit(x, y, m);
X(1, :) = linspace(0, 1, n);
X(2, :) = polyval(polyfun, X(1, :));



