function pos = smoothP(vels, st, w)
% Find the most smooth point (with the maximum velocity) of a motion.

if ~exist('w', 'var'), w = 5; end

n = length(vels);
if isempty(st), st = [1, n + 1]; end

m = length(st) - 1;
pos = zeros(1, m);

for iM = 1 : m
    velMax = 0; pos(iM) = st(iM);
    for i = st(iM) : st(iM + 1) - w
        head = i; tail = i + w - 1;
        vel = sum(vels(head : tail)) / w;
        if vel > velMax
            velMax = vel;
            pos(iM) = i + floor(w / 2);
        end
    end
end
