function paraF = getMOCParaF(type)
% Get feature parameter for the specified motion source.
%
% Input 
%   source    -  motion source
%
% Output
%   paraF
%     filter  -  filter methods
%     feat    -  feature for each dof
%     used    -  used joints
%     fps     -  frame per seconds
%     offset  -  offset of mocap source
%     range   -  range of used frames
%     reduce  -  reduce flag
%     maxRed  -  temporal reduction
%
% History
%   create    -  Feng Zhou, 02-13-2009
%   modify    -  SV, 05-19-2009


% filter method & fps
if strcmp(type, 'mocap')
    paraF.filter = 'barbic';
    paraF.fps = 120;
    paraF.reduce = 'y';
    paraF.maxRed = 5;
    paraF.offset = 1;

elseif strcmp(type, 'kitchen')
    paraF.filter = 'arm';
%     paraF.filter = 'arm+leg+torso';
%    paraF.fps = 30;
    paraF.fps = 120;
    paraF.reduce = 'n';
    
    % offset for synchorinzing with video
        paraF.offset = 1;

else
    error(['unknown mocap type: ' type]);
end

paraF.feat = 'log';
paraF.used = [];
paraF.path = 'n';
paraF.range = [];