function wsFeat = mocFeat(wsDOF, paraF)
% Obtain the mocap features.
%
% Input
%   wsDOF   
%   paraF
%   varargin
%
% Output
%   wsFeat
%     DOF    -  DOF matrix by filtering the joints, dim x nF 
%     joint  -  joint that remaines after the filter
%     X      -  feature matrix by converting the DOF, dim x nF
%
% History
%   create   -  Feng Zhou, 02-13-2009
%   modify   -  SV, 05-19-2009


fprintf('obtaining the feature...\n');
% feature
[DOF, joint] = dofFilter(wsDOF.DOF, wsDOF.joint, paraF);
X = dof2feat(DOF, joint, paraF);

wsFeat.DOF = DOF;
wsFeat.joint = joint;
wsFeat.X = X;

