function vis = dec2vis(dec, m)
% Convert decimal to binary number in binary vector.
% For example, dec = 10 -> vis = [0, 1, 0, 1]
%
% Input
%   dec     -  decimal value
%   m       -  number of bits, (optional)
%
% Output
%   vis     -  binary vector, 1 x m
%
% History
%   create  -  Feng Zhou, 02-27-2009
%   modify  -  Feng Zhou, 02-27-2009

s = dec2bin(dec);
s = s(end : -1 : 1);
m0 = length(s);

if ~exist('m', 'var')
    m = m0;
end

vis = zeros(1, m);
for i = 1 : min(m, m0);
    if strcmp(s(i), '1')
        vis(i) = 1;
    end
end
