function H = n2H(ns)
% Generate the indicator matrix from the given length vectors.
% For example, ns = [1 3 2] => H = [1 0 0 0 0 0; ...
%                                   0 1 1 1 0 0; ...
%                                   0 0 0 0 1 1];
%
% Input
%   ns      -  frame length, 1 x m
%
% Output
%   st      -  starting position of each segment, 1 x (m + 1)
%
% History
%   create  -  Feng Zhou, 01-31-2009
%   modify  -  Feng Zhou, 01-31-2009

m = length(ns);
st = n2st(ns);
n = st(m + 1) - 1;

H = zeros(m, n);
for i = 1 : m
    H(i, st(i) : st(i + 1) - 1) = 1;
end