function st = n2st(ns)
% Join the vector of frame length together.
%
% Example
%   ns = [1 3 5 3] -> st = [1 2 5 10 13]
%
% Input
%   ns      -  frame length, 1 x m
%
% Output
%   st      -  starting position of each segment, 1 x (m + 1)
%
% History
%   create  -  Feng Zhou, 01-30-2009
%   modify  -  Feng Zhou, 01-30-2009

m = length(ns);

st = ones(1, m + 1);
for i = 1 : m
    st(i + 1) = st(i) + ns(i);
end
