function timestamp = secs2timestamp (secs, format)

if ~isempty(find(isnan(secs), 1)) || size(secs, 2) > 1
    disp('The input to SECS2TIMESTAMP was not a column array of numbers.');
    beep;
    return;
end

if ~ischar(format) || length(format)~=12
    disp('The input to SECS2TIMESTAMP was not a proper string.');
    beep;
    return;
end
% Actually another convention for format could be choosen. In this case we
% try to be compatible with datenum and datestr for timestamps including
% HH_MM_SS_FFF


% Once the format is correct...
%timestamp = cell(length(secs), 1);

for i=1:length(secs)

    HH = num2str(floor(secs(i)/3600));
    if length(HH)<2
    	HH = ['0' HH];
    end

    rest = mod(secs(i), 3600);
    if rest ~= 0
        
        MM = num2str(floor(rest/60));
        if length(MM)<2
            MM = ['0' MM];
        end
        
        SS = num2str(mod(rest, 60), '%2.6f');
        if length(SS)<9
            SS = ['0' SS];
        end
              
    else
        MM = ['0' num2str(0)];
        SS = ['0' num2str(0,'%.6f')];
    end
    
    timestamp{i} = [HH format(3) MM format(6) SS(1:2) format(9) SS(4:length(SS))];
end
timestamp = timestamp';