function secs = timestamp2sec (str)


if ischar(str)
    str=cellstr(str);
end
if ~iscell(str) || size(str, 2) > 1
    disp('The input to TIMESTAMP2SEC was not a column array of strings.');
    beep;
    return;
end

secs = zeros(length(str), 1);

% Now we have the right format
for i=1:length(str)
    if ~isempty(str{i})
        time = str{i};
        HH = str2num(time(1:2));
        MM = str2num(time(4:5));
        SS = str2num(time(7:8));
        UU = str2num(time(10:length(time)));
        secs(i) = HH*3600 + MM*60 +SS +UU/10^(length(time) - 9);
    else
        secs(i) = 0;
    end
end




